/* 
   code by la1n.ch
   more details:  "about the source ... " 
*/

/* l1neumController.m */

#import "l1neumController.h"

@interface l1neumController (InternalMethods)
- (void) setupRenderTimer;
- (void) updateGLView:(NSTimer *)timer;
- (void) createFailed;
@end

@implementation l1neumController

- (void) awakeFromNib
{  
	// awake me - wake up
	
	
	
	
	

   // open it
   [ NSApp setDelegate:self ];   // We want delegate notifications
   renderTimer = nil;
   [ glWindow makeFirstResponder:self ];
   glView = [ [ l1neumView alloc ] initWithFrame:[ glWindow frame ]
              colorBits:16 depthBits:16 fullscreen:FALSE ];
   if( glView != nil )
   {
	  [ glWindow center ];
      [ glWindow setContentView:glView ];
      [ glWindow makeKeyAndOrderFront:self ];
      [ self setupRenderTimer ];
	  
	  // setDefaults
	  NSUserDefaults *prefs = [[NSUserDefaults standardUserDefaults] retain];
	  [glView setUserDefaults: prefs];
   }
   else
      [ self createFailed ];
}  




//  set timer for render/redraw
- (void) setupRenderTimer
{
   // refresh openglview
   NSTimeInterval timeInterval = 0.05;

   renderTimer = [ [ NSTimer scheduledTimerWithTimeInterval:timeInterval
                             target:self
                             selector:@selector( updateGLView: )
                             userInfo:nil repeats:YES ] retain ];
   [ [ NSRunLoop currentRunLoop ] addTimer:renderTimer
                                  forMode:NSEventTrackingRunLoopMode ];
   [ [ NSRunLoop currentRunLoop ] addTimer:renderTimer
                                  forMode:NSModalPanelRunLoopMode ];

	// refresh game circle
	// doGameCircle
	   NSTimeInterval timeIntervalgamecirlce = 0.002;

   gameCircleTimer = [ [ NSTimer scheduledTimerWithTimeInterval:timeIntervalgamecirlce
                             target:self
                             selector:@selector( doGameCircle: )
                             userInfo:nil repeats:YES ] retain ];
   [ [ NSRunLoop currentRunLoop ] addTimer:gameCircleTimer
                                  forMode:NSEventTrackingRunLoopMode ];
   [ [ NSRunLoop currentRunLoop ] addTimer:gameCircleTimer
                                  forMode:NSModalPanelRunLoopMode ];

}


// update the glview direct
- (void) updateGLView:(NSTimer *)timer
{
   if( glView != nil )
      [ glView drawRect:[ glView frame ] ];
}  

// do gamecircle timer
- (void) doGameCircle:(NSTimer *)timer
{
   if( glView != nil )
      [ glView doGameCircle ];
}  




// go to fullscreen
// seems not to work at the moment
- (IBAction)setFullScreen:(id)sender
{
   [ glWindow setContentView:nil ];
   if( [ glView isFullScreen ] )
   {
      if( ![ glView setFullScreen:FALSE inFrame:[ glWindow frame ] ] )
         [ self createFailed ];
      else
         [ glWindow setContentView:glView ];
   }
   else
   {
      if( ![ glView setFullScreen:TRUE
                    inFrame:NSMakeRect( 0, 0, 800, 600 ) ] )
         [ self createFailed ];
   }
}


// init failed
- (void) createFailed
{
   NSWindow *infoWindow;

   infoWindow = NSGetCriticalAlertPanel( @"Initialization failed",
                                         @"Failed to initialize OpenGL",
                                         @"OK", nil, nil );
   [ NSApp runModalForWindow:infoWindow ];
   [ infoWindow close ];
   [ NSApp terminate:self ];
}


// dealloc
- (void) dealloc
{
   [ glWindow release ]; 
   [ glView release ];
   if( renderTimer != nil && [ renderTimer isValid ] )
      [ renderTimer invalidate ];
}


// 
// handle keystrokes
 
//
// key down till key up !!!
//
- (void) keyDown:(NSEvent *)theEvent
{
   unichar unicodeKey;

   unicodeKey = [ [ theEvent characters ] characterAtIndex:0 ];

   // for inserting highscore & cheat codes ?
    if (![theEvent isARepeat])
	 [glView keyDownDirect:unicodeKey];

   // NSLog(@"l1neumController.keyDown=%d",unicodeKey);

   switch( unicodeKey )
   {
   
        /// left
        case NSLeftArrowFunctionKey:
            [ glView  setKeyStatus: 1  value:true];
        break;
        
        // right
        case NSRightArrowFunctionKey:
            [ glView  setKeyStatus: 2   value:true];
        break;
        
        // up
        case NSUpArrowFunctionKey:
			[ glView  setKeyStatus: 3   value:true ];
        break;
        
        // down
        case NSDownArrowFunctionKey:
            [ glView setKeyStatus: 4   value:true];
        break;
        
        // space
        case ' ':
		
			[ glView setKeyStatus: 5   value:true];
			
			/*
			// do action ..
			[glView doAction: true];
			
            if (![theEvent isARepeat])
            {
                // [ glView addShoot ];
            }
			*/
               
        break;
		
		 // return
        case 13:
			[ glView setKeyStatus: 5   value:true];
		break;

		// 0
        case 48:
			[ glView setKeyStatus: 5   value:true];
		break;


		// pause - escape
		// space
        case 'p':
		
			[ glView setKeyStatus: 6   value:true];
		       
        break;
		 case 27:
		
			[ glView setKeyStatus: 6   value:true];
		       
        break;
		
		
		


   }

}

- (void) keyUp:(NSEvent *)theEvent
{
   unichar unicodeKey;

   unicodeKey = [ [ theEvent characters ] characterAtIndex:0 ];

	// NSLog(@"l1neumController.keyDown=%d",unicodeKey);

   switch( unicodeKey )
   {
   
        /// left
        case NSLeftArrowFunctionKey:
            [ glView  setKeyStatus: 1  value:false];
        break;
        
        // right
        case NSRightArrowFunctionKey:
            [ glView  setKeyStatus: 2   value:false];
        break;
        
        // up
        case NSUpArrowFunctionKey:
			[ glView  setKeyStatus: 3   value:false ];
        break;
        
        // down
        case NSDownArrowFunctionKey:
            [ glView setKeyStatus: 4   value:false];
        break;
        
        // space
        case ' ':
		
			[ glView setKeyStatus: 5   value:false];
			
               
        break;

   }

}

@end