/* 
   code by la1n.ch
   more details:  "about the source ... " 
*/


/* l1neumView.m */
#import <OpenGL/OpenGL.h>
#import <OpenGL/gl.h>
#import <OpenGL/glu.h>

#import <Screensaver/ScreenSaver.h>

// sound
#import <Quicktime/Quicktime.h>
#import "l1neumView.h"

#import "tpObject.h"
#import "tboOnFire.h"


#import "objectWall.h"

@interface l1neumView (InternalMethods)
- (NSOpenGLPixelFormat *) createPixelFormat:(NSRect)frame;
- (void) switchToOriginalDisplayMode;
- (BOOL) initGL;
- (BOOL) loadGLTextures;
- (BOOL) loadBitmap:(NSString *)filename intoIndex:(int)texIndex;
@end

@implementation l1neumView

- (id) initWithFrame:(NSRect)frame colorBits:(int)numColorBits
       depthBits:(int)numDepthBits fullscreen:(BOOL)runFullScreen
{
   NSOpenGLPixelFormat *pixelFormat;

   colorBits = numColorBits;
   depthBits = numDepthBits;
   runningFullScreen = runFullScreen;
   originalDisplayMode = (NSDictionary *) CGDisplayCurrentMode(
                                             kCGDirectMainDisplay );
   xrot = yrot = zrot = 0;
   

	// zoom it ..

   [[self window] center]; 
   
   // ---------------
   // debug
   // ---------------
   debugPlayField=false;
   
   debugRotateF=false;

   // ---------------
	// music
   // ---------------
   soundTitlePlay=true;

   // sounds ??
   soundEffects=true;
	
	
   // --------------------
   // game
   // --------------------
 
   // --------------------
   // hiscores
   // --------------------
   hiScoresName =[[NSMutableArray alloc] init];
   int t=0;
   for (t=0;t<10;++t)
   {
	  hiScoresPoints[t]=(t+1)*10000;
	  NSMutableString * nexts=[[NSMutableString alloc] initWithFormat:@"%@",@"qix"];
	  if (t==0) [nexts setString:@"coin"];
	  if (t==1) [nexts setString:@"intell"];
	  if (t==2) [nexts setString:@"ivsion"];
	  if (t==3) [nexts setString:@"arcade"];
	  if (t==4) [nexts setString:@"sparx"];
	  if (t==5) [nexts setString:@"fuse"];
	  if (t==6) [nexts setString:@"sparx"];
	  if (t==7) [nexts setString:@"styx"];
	  if (t==8) [nexts setString:@"qix"];
	  if (t==9) [nexts setString:@"volfied"];
	  
	  [ hiScoresName addObject: nexts ];
   }
   positionInHighscores=-1;
   highscoreInsertMode=false;
     
   // percent
   percent=0.0f;
   
   // --------------------
   // animation counter
   // --------------------
   animationCounter=0;
   animationCounterDirect=0;
   animationReverse=false;

   // --------------------
   // systemMode
   // --------------------
   // start in game
   
   // 2 / 1 game/gamein
   systemMode=2;
   systemModeSub=1;
   // activate submode
   systemModeSubMode=-1; // not active ..
   
   // subsettings
   systemModeSubSettings=0;
   
   // window
   systemWindowModeBig=false;
   
   // music setting
   systemMusic=true;
   // emotics ? emotions 
   systemEmotions=false;
   
   // counter
   systemModeSubCounter=0;
	
   // start 
   systemMode=0;
   systemModeSub=0;	

	// menuTimer
	menuTimer=0.0f;


   // --------------------
   // emotion
   // --------------------
    emotionLevel=0.7f;

    emotionLevelA=0.0f;
	emotionLevelADirection=0;
	emotionLevelASpeed=0.001f;
	emotionLevelMaxA=0.10f;

	// X
    emotionLevelAX=0.0f;
	emotionLevelAXDirection=1;
	emotionLevelAXSpeed=0.0005f;
	emotionLevelMaxAX=0.15f;

	// Y
    emotionLevelAY=0.0f;
	emotionLevelAYDirection=0;
	emotionLevelAYSpeed=0.0005f;
	emotionLevelMaxAY=0.10f;
	

  
   // ----------------
   // position 
   // ----------------
   
   // values -> look at nextLEvel
   originxrot=0.0f;
   originyrot=0.0f; // 0.0f
   originzrot=10.0f;
  
   
   xrot=originxrot;
   yrot=originyrot; // 0.0f
   zrot=originyrot;
 
 
   // offset
   xoffset=0.0f;
   yoffset=0.0f;
   zoffset=-40.0f;

   // scale
   scalePlayFieldX=0.105f;
   scalePlayFieldY=0.07f;
   scalePlayFieldZ=0.8f;

   heightFloor=2;
   heightTopFloor=3;

   // fogFlag
   fogFlag=false;

   // scaleWall=
   
   // help
   oldPositionX=0;
   oldPositionY=0;
   
   
   // -------------------
   // playfield
   // -------------------
	playFieldCountX=400;
	playFieldCountY=400;
	
	// xoffset=playFieldCountX/2;
	
	int z=0;
	int zz=0;
	for (z=0;z<playFieldCountX;++z)
	 for (zz=0;zz<playFieldCountY;++zz)
	 {
		playField[z][zz]=0;
	 }
	 
	   // --------------------
	   // graphics
	   // --------------------
	   //  0 - nothing (black)
	   //  1 - a little bit more (background)
	   // 10 - all
	   graphics=10;
		 
	 // ---------------
	 // texture  
	 // ---------------

	// chars
	textureChars=100;

	// ingame
	 textureBackground=4;
	 textureLogo=17;
	 textureScore=0;
	 textureLogoBackground=9;
	 textureFireLine=10;
	 textureShipBackground=11;
	 textureShipBackgroundFireLine=12;
	 textureHunter=13;
	 
	 // title
	 textureTitle=15;
	 textureTitleCredits=16;
	 
	 // menu
	 textureMenu=18;
	 textureMenuItems=19;
	 
	 textureMenuSubSettings=35;
	 textureMenuSubRulez=33;
	 textureMenuSubHighscore=34;
	 textureMenuSubHighscoreInsert=7;
	 
	 // game over
	 textureGameOver=37;
	 
	 // finished
	 textureFinished=38;
	 
	 // walls etc
	 //   
	 textureWallTop=1;
	 // |
	 textureWallFront=2;
	 // --
	 textureWallSide=3;

	 // game background
	 textureGameBackground=4;
	 
	 // next level
	 textureGameActualLevel=5;
	 textureGameActualLevelTransparent=1.0f;
	 textureGameNextLevel=6;
	
	// representation
	textureRepresentation=8;
	textureRepresentationShield=10;
	
	// enemies
	textureEnemyBigBoss=30;
	textureEnemy=31;
	textureEnemyFly=32;
	
	// bonus
	textureBonus=14;
	textureBonusBase=40;
	
	bonusShield=0.0f;
	bonusTimeout=0.0f;
	bonusSpeedup=0.0f;
	
	// interactive ?
	texturePaused=36;
	texturePausedExit=39;
	
	// game over
	
	// end of the game ..
	
	 // alpha numer.
	 textureNumber=20;
	 
	 
	 // fireline vertical ?
	 displayFireLineVertical=false;
	 
	 
	 // ---------------
	 // objects
	 // ---------------
	 objects=[[NSMutableArray alloc] init];


	// --------------------
	// representation
	// --------------------
	representation=[[tpObject alloc] init];
	[representation initObject];
	[representation setTypeId: 1];
	[representation setType:@"representation"];
	[representation setPosition: NSMakePoint(1,1)];
	// add respresentation
	[objects addObject:representation];
	
	// gameShield
	shield=0.0f;
	
	// --------------------
	// enemy
	// --------------------
	enemyBoss=[[tboEnemyBigBoss alloc] init];
	[enemyBoss initObject];
	[enemyBoss setPosition: NSMakePoint(playFieldCountX/2,playFieldCountY/2)];
	[enemyBoss setType:@"enemyBoss"];
	// add enemyBoss
	[objects addObject:enemyBoss];
	
	enemyBigWidth=60;
	enemyBigHeight=60;

	enemyWidth=30;
	enemyHeight=30;

	enemyFlyWidth=20;
	enemyFlyHeight=20;
	

	enemyShootType=1;

	// ---------------
	// small enemies
	// ---------------
	// 10 enemies
	int e=0;
	for (e=0;e<10;++e)
	{
		// add enemy
		tboEnemy * enemyx=[[tboEnemy alloc] init];
		[enemyx initObject];
		[enemyx setPosition: NSMakePoint(SSRandomIntBetween(3,playFieldCountX/2-42),SSRandomIntBetween(3,playFieldCountY/2-42))];
		[enemyx setStatus:0];
		
		[objects addObject:enemyx];
		
		// 4 flying
		if (e<4)
		{
			[enemyx setSize:NSMakePoint(20,20)];
			[enemyx setFlyingFlag:true];
		}
	}

	// ---------------
	// bonus
	// ---------------
	// 20 bonus
	for (e=0;e<20;++e)
	{
		// add enemy
		tboBonus * bonus=[[tboBonus alloc] init];
		[bonus initObject];
		[bonus setPosition: NSMakePoint(SSRandomIntBetween(3,playFieldCountX/2),SSRandomIntBetween(3,playFieldCountY/2))];
		[bonus setStatus:0];
		// [bonus setTypeId:3];
		// [bonus setSize:NSMakePoint(20,20)];
		[objects addObject:bonus];

		if (e<9)
		{
			[bonus setTypeIdSub:e];
			[bonus setStatus:3];
		}
	}
	
	

	// ---------------------
	// fireRunners
	// ---------------------
	enemyRunner1=[[tboOnFire alloc] init];
	[enemyRunner1 initObject];
	[enemyRunner1 setPosition: NSMakePoint(playFieldCountX/2,playFieldCountY/2)];
	[enemyRunner1 setStatus:0];
	[objects addObject:enemyRunner1];
	
	enemyRunner2=[[tboOnFire alloc] init];
	[enemyRunner2 setPosition: NSMakePoint(playFieldCountX/2,playFieldCountY/2)];
	[enemyRunner2 initObject];
	[enemyRunner2 setStatus:0];
	[enemyRunner2 setDirectionType:-1];
	[objects addObject:enemyRunner2];
	
	

	// make a some lines
	// -----
	// -----
	for (zz=0;zz<playFieldCountY;++zz)
	 {
		playField[zz][0]=1;
		playField[zz][playFieldCountY-1]=1;
		
		// the line
		playField[zz][1]=2;
		playField[zz][playFieldCountY-2]=2;
	 }

	// |	|
	// |	|
	for (zz=1;zz<playFieldCountY-1;++zz)
	 {
		playField[0][zz]=1;
		playField[playFieldCountY-1][zz]=1;
		
		// the line
		playField[1][zz]=2;
		playField[playFieldCountY-2][zz]=2;
	 }
	 
   // a speical 
   // playField[3][2]=1;
   
   	 // ---------------
	 // walls
	 // ---------------
	 walls=[[NSMutableArray alloc] init];

	 // ----------------
	 // keys
	 // ----------------
	 statusMove1=false;
	 statusMove2=false;
	 statusMove3=false;
	 statusMove4=false;
	 
	 statusFire=false;
	 
	 keyCounter=0;
   
   // reset level
   [self resetLevel];
   
   // reset game
   [self resetGame];
   
   
	// -------------------------------------------------------
	// music
	// -------------------------------------------------------
	// titleTheme
	musicTitleTheme = [[NSMovie alloc]
			  initWithURL:  [NSURL fileURLWithPath: [[NSBundle mainBundle] pathForResource: @"titleTheme" ofType: @"mp3"]]
			  byReference: YES];
    // inGame
	musicInGame = [[NSMovie alloc]
			  initWithURL:  [NSURL fileURLWithPath: [[NSBundle mainBundle] pathForResource: @"inGame" ofType: @"mp3"]]
			  byReference: YES];

	// -------------------------------------------------------
	// sound / effects center
	// -------------------------------------------------------
	soundEffectsArray=[[NSMutableArray alloc] init];
	soundEffectsName=[[NSMutableArray alloc] init];

	// -------------------------------------------------------
	// sound / effects
	// -------------------------------------------------------
	// menu sound
    soundMenuNextPoint  = [NSSound soundNamed:@"soundMenuNextPoint"];
    soundMenuPointDone  = [NSSound soundNamed:@"soundMenuPointDone"];
   
    // enemy
    soundEnemyDie  = [NSSound soundNamed:@"soundEnemyDie"];
    soundEnemyDieHard  = [NSSound soundNamed:@"soundEnemyDieHarder"];

	// big enemy
	//
    soundBigBossShoot  = [NSSound soundNamed:@"soundBigBossShoot"];
	
	soundEnemyBoing = [NSSound soundNamed:@"soundEnemyBoing"];

	// representation
    soundVesselDie  = [NSSound soundNamed:@"soundVesselDie"];
	soundVesselTerrain=[NSSound soundNamed:@"soundVesselTerrain"];
	soundVesselNoWay=[NSSound soundNamed:@"soundVesselNoWay"];
	
	// soundFireLineEnd
	soundFireLineEnd=[NSSound soundNamed:@"soundFireLineEnd"];
	
	
	// gameover
    soundGameOver  = [NSSound soundNamed:@"soundGameOver"];
	// nextLEvel
	// soundNextLevel
    soundNextLevel  = [NSSound soundNamed:@"soundNextLevel"];
   
   // bonus 
   soundBonusFree= [NSSound soundNamed:@"soundBonusFree"];
   // soundBonusFree
   
   
   
   // usage : [[[soundMenuNextPoint copy] autorelease] play];
   
   // pixelformat
   pixelFormat = [ self createPixelFormat:frame ];
   if( pixelFormat != nil )
   {
      self = [ super initWithFrame:frame pixelFormat:pixelFormat ];
      [ pixelFormat release ];
      if( self )
      {
         [ [ self openGLContext ] makeCurrentContext ];
         if( runningFullScreen )
            [ [ self openGLContext ] setFullScreen ];
         [ self reshape ];
         if( ![ self initGL ] )
         {
            [ self clearGLContext ];
            self = nil;
         }
      }
	  
   // ---------------
   // center window
   // ---------------
	NSRect frame = [[self window] frame];
	frame.size.width=800;
	frame.size.height=570;
	
	[[self window] setFrame:frame display:YES animate:false];
	[ self reshape ];
   }
   else
      self = nil;

   return self;
}

// set DefaultObject && load prefs
- (void) setUserDefaults: (NSUserDefaults *) iprefs
{

	// NSLog(@"l1neumView.setUserDefaults  (loadPrefs)");

	prefs=iprefs;
	
	// check if there is yet an 
	// highscore prefs


	NSMutableArray * hiScores =[[NSMutableArray alloc] init];
		
	if ( [prefs objectForKey:@"hiScores"] != nil ) 
	{
		hiScores = [[NSMutableArray alloc] initWithArray:[prefs arrayForKey:@"hiScores"]];
	
		// NSLog(@"l1neumView.setUserDefaults.%@",hiScores);
	
			// load into the game arrays
		int i=0;
		for (i=0;i<[hiScores count];++i)
		{
			NSMutableString * parse=[hiScores objectAtIndex:i];
			
			// NSLog(@"l1neumView.setUserDefaults: %d %@",i,parse);
		
			NSRange rang=[parse rangeOfString:@"|"];
			// NSLog(@"found=%d", rang.location);
			NSString *longstr=[parse substringToIndex:rang.location];
			hiScoresPoints[i]=[longstr intValue];
			
			// ..
			NSMutableString * namemt = [hiScoresName objectAtIndex:i];
			[namemt setString:[parse substringFromIndex:(rang.location+1)]];
		}
	} 
	
			

	
	
}

// savePrefs
- (void) savePrefs
{
	NSLog(@"l1neumView.savePrefs");
	
	NSMutableArray * hiScores =[[NSMutableArray alloc] init];
	
	hiScores = [[NSMutableArray alloc] init];
	
	int z=0;
	for (z=0;z<10;++z)
	{   
		NSString * strname = [hiScoresName objectAtIndex:z];
		NSMutableString * scoreStr= [[NSMutableString alloc] initWithFormat:@"%d|%@",hiScoresPoints[z],strname];
		[hiScores addObject:scoreStr];
	}
	
	[prefs setObject:hiScores forKey:@"hiScores"];

}


/*
 * Create a pixel format and possible switch to full screen mode
 */
- (NSOpenGLPixelFormat *) createPixelFormat:(NSRect)frame
{
   NSOpenGLPixelFormatAttribute pixelAttribs[ 16 ];
   int pixNum = 0;
   NSDictionary *fullScreenMode;
   NSOpenGLPixelFormat *pixelFormat;

   pixelAttribs[ pixNum++ ] = NSOpenGLPFADoubleBuffer;
   pixelAttribs[ pixNum++ ] = NSOpenGLPFAAccelerated;
   pixelAttribs[ pixNum++ ] = NSOpenGLPFAColorSize;
   pixelAttribs[ pixNum++ ] = colorBits;
   pixelAttribs[ pixNum++ ] = NSOpenGLPFADepthSize;
   pixelAttribs[ pixNum++ ] = depthBits;

   if( runningFullScreen )  // Do this before getting the pixel format
   {
      pixelAttribs[ pixNum++ ] = NSOpenGLPFAFullScreen;
      fullScreenMode = (NSDictionary *) CGDisplayBestModeForParameters(
                                           kCGDirectMainDisplay,
                                           colorBits, frame.size.width,
                                           frame.size.height, NULL );
      CGDisplayCapture( kCGDirectMainDisplay );
      CGDisplayHideCursor( kCGDirectMainDisplay );
      CGDisplaySwitchToMode( kCGDirectMainDisplay,
                             (CFDictionaryRef) fullScreenMode );
   }
   pixelAttribs[ pixNum ] = 0;
   pixelFormat = [ [ NSOpenGLPixelFormat alloc ]
                   initWithAttributes:pixelAttribs ];

   return pixelFormat;
}


//  fullscreenmode ?
// seems work
- (BOOL) setFullScreen:(BOOL)enableFS inFrame:(NSRect)frame
{
   BOOL success = FALSE;
   NSOpenGLPixelFormat *pixelFormat;
   NSOpenGLContext *newContext;

   [ [ self openGLContext ] clearDrawable ];
   if( runningFullScreen )
      [ self switchToOriginalDisplayMode ];
   runningFullScreen = enableFS;
   pixelFormat = [ self createPixelFormat:frame ];
   if( pixelFormat != nil )
   {
      newContext = [ [ NSOpenGLContext alloc ] initWithFormat:pixelFormat
                     shareContext:nil ];
      if( newContext != nil )
      {
         [ super setFrame:frame ];
         [ super setOpenGLContext:newContext ];
         [ newContext makeCurrentContext ];
         if( runningFullScreen )
            [ newContext setFullScreen ];
         [ self reshape ];
         if( [ self initGL ] )
            success = TRUE;
      }
      [ pixelFormat release ];
   }
   if( !success && runningFullScreen )
      [ self switchToOriginalDisplayMode ];

   return success;
}


/// switch to original display mode
- (void) switchToOriginalDisplayMode
{
	NSLog(@"l1neumView.switchToOriginalDisplayMode");
   CGDisplaySwitchToMode( kCGDirectMainDisplay,
                          (CFDictionaryRef) originalDisplayMode );
   CGDisplayShowCursor( kCGDirectMainDisplay );
   CGDisplayRelease( kCGDirectMainDisplay );
}


/// init opengl
- (BOOL) initGL
{
   if( ![ self loadGLTextures ] )
      return FALSE;

   glEnable( GL_TEXTURE_2D );                // Enable texture mapping
   glShadeModel( GL_SMOOTH );                // Enable smooth shading
   glClearColor( 0.0f, 0.0f, 0.0f, 0.5f );   // Black background
   glClearDepth( 1.0f );                     // Depth buffer setup
   glEnable( GL_DEPTH_TEST );                // Enable depth testing
   glDepthFunc( GL_LEQUAL );                 // Type of depth test to do
   // Really nice perspective calculations
   glHint( GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST );

   // new
  // glEnable( GL_BLEND );                // Enable texture mapping
   glBlendFunc( GL_SRC_ALPHA, GL_ONE );
   glColor4f( 1.0f, 1.0f, 1.0f, 0.2f );   // Full brightness, 50% alpha
 

  // glEnable(GL_CULL_FACE);
  glDepthMask(GL_TRUE);
  // glEnable( GL_LIGHTING );
  // glEnable(GL_COLOR_MATERIAL); 
  
  
 // fog '
   if (fogFlag)
   {
		// fog
		glEnable(GL_BLEND);
		glEnable(GL_FOG);
		float fog_color[4] = { 0.0f, 0.4f, 0.0f, 0.6f };
        glFogfv(GL_FOG_COLOR, fog_color);    
        glFogi(GL_FOG_MODE, GL_LINEAR);
        // GL_LINEAR, GL_EXP, GL_EXP2, and GL_FOG_FUNC_EXT
        glFogf(GL_FOG_DENSITY, 0.1f);
        glFogf(GL_FOG_START, zoffset-1.0f);
        glFogf(GL_FOG_END, zoffset-5.0f);
	}
		
	glCullFace( GL_FRONT );                    // Set Culling Face To Back Face
    glCullFace( GL_BACK );
   
   return TRUE;
}


// load all textures
- (BOOL) loadGLTextures
{
   BOOL status = true;

	int y=0;
	
	for (y=0;y<127;++y)
	{
			status = TRUE;
			// NSString *path=@"level0animation0.bmp";
			NSString *path = [NSString localizedStringWithFormat:@"texture%d.jpg",y];
			
			// load chars 
			if (y>100) 
			  path = [NSString localizedStringWithFormat:@"textureChar%d.jpg",(y-100)];
			
			if( [ self loadBitmap:[ NSString stringWithFormat:@"%@/%@", [ [ NSBundle mainBundle ] resourcePath ],path ] intoIndex:0 ] )
			{
				  // NSLog(@"Lession06View.loadingTexture:(%@) found ",path);
				
				  glGenTextures( 1, &textureArray[ textureIndex ] );   // Create the texture
				  glBindTexture( GL_TEXTURE_2D, textureArray[ textureIndex ] );
				  glTexImage2D( GL_TEXTURE_2D, 0, 3, texSize[ 0 ].width,texSize[ 0 ].height, 0, texFormat[ 0 ], GL_UNSIGNED_BYTE, texBytes[ 0 ] );
				  glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
				  glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
				  free( texBytes[ 0 ] );
				  
				
				// add index
				  ++textureIndex;
				  
				  
			}
			else
			{
				NSLog(@"Lession06View.loadingTexture:(%@) not found ",path);
			}
			
			// NSLog(@"l1neumView.texturesetArray.temptexture.count:%d",[temptexture getTextureCounter]);
		
	}

  

   return status;
}


// load a bitmap ..
- (BOOL) loadBitmap:(NSString *)filename intoIndex:(int)texIndex
{
   BOOL success = FALSE;
   NSBitmapImageRep *theImage;
   int bitsPPixel, bytesPRow;
   unsigned char *theImageData;
   int rowNum, destRowNum;

   theImage = [ NSBitmapImageRep imageRepWithContentsOfFile:filename ];
   if( theImage != nil )
   {
      bitsPPixel = [ theImage bitsPerPixel ];
      bytesPRow = [ theImage bytesPerRow ];
      if( bitsPPixel == 24 )        // No alpha channel
         texFormat[ texIndex ] = GL_RGB;
      else if( bitsPPixel == 32 )   // There is an alpha channel
         texFormat[ texIndex ] = GL_RGBA;
      texSize[ texIndex ].width = [ theImage pixelsWide ];
      texSize[ texIndex ].height = [ theImage pixelsHigh ];
      texBytes[ texIndex ] = calloc( bytesPRow * texSize[ texIndex ].height,
                                     1 );
      if( texBytes[ texIndex ] != NULL )
      {
         success = TRUE;
         theImageData = [ theImage bitmapData ];
         destRowNum = 0;
         for( rowNum = texSize[ texIndex ].height - 1; rowNum >= 0;
              rowNum--, destRowNum++ )
         {
            // Copy the entire row in one shot
            memcpy( texBytes[ texIndex ] + ( destRowNum * bytesPRow ),
                    theImageData + ( rowNum * bytesPRow ),
                    bytesPRow );
         }
      }
   }

   return success;
}


// resize the window
- (void) reshape
{ 
   //	NSLog(@"l1neumView.reshape");
   
   NSRect sceneBounds;
   
   [ [ self openGLContext ] update ];
   sceneBounds = [ self bounds ];
   // Reset current viewport
   glViewport( 0, 0, sceneBounds.size.width, sceneBounds.size.height );
   glMatrixMode( GL_PROJECTION );   // Select the projection matrix
   glLoadIdentity();                // and reset it
   // Calculate the aspect ratio of the view
   gluPerspective( 45.0f, sceneBounds.size.width / sceneBounds.size.height,
                   0.1f, 100.0f );
   glMatrixMode( GL_MODELVIEW );    // Select the modelview matrix
   glLoadIdentity();                // and reset it
}


// draw rect
// draw is called from a timer in l1neumController

// each mode has his "own" draw
// systemMode==0 -> drawRectIntro
// systemMode==1 -> drawRectMenu
// systemMode==2 -> drawRectGame

- (void) drawRect:(NSRect)rect
{

  // ------------------
   // intro
   // ------------------
   if (systemMode==0)
	{
		
		// start music ..
		if (systemModeSub==0)
		{
		}
		
		// display
		[self drawRectIntroTitle];
	}
	
	// ------------------
   // menu
   // ------------------
   if (systemMode==1)
	{
			// the menu
			[self drawRectMenu];
			
	}
	
   // ------------------
   // game
   // ------------------
   if (systemMode==2)
	{
			// the game
			[self drawRectGame];
			
	}
		
  
}

				// -------------------------------------
				// drawRectIntroTitle
				// -------------------------------------
				- (void) drawRectIntroTitle
				{
				  	
					 // Clear the screen and depth buffer
					   glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

					   // -----------------------
					   // reset trigo
					   // -----------------------
					   glLoadIdentity();   // Reset the current modelview matrix

					   glTranslatef( 0.0f, 0.0f, -40.0f );      // Move into screen 5 units


					  glEnable(GL_BLEND);
					  glColor4f( 1.0f, 1.0f, 1.0f, 1.0f );
					 
					 
					  // glBlend
					  // systemModeSubCounter
					  if ((systemModeSub==1) || (systemModeSub==0) ||  (systemModeSub==10))
					  {
						  glEnable(GL_BLEND);
						  long ipos=systemModeSubCounter;
						  if (ipos==0)
						    ipos=1000;
						  glColor4f( 1.0f, 1.0f, 1.0f, 1.0f-((float) ipos)/1000.0f );
						  
						  // blend out
						  if (systemModeSub==10)
						     glColor4f( 1.0f, 1.0f, 1.0f, ((float) ipos)/1000.0f );
					  }
					  
					  // NSLog(@"l1neumView.drawRectIntroTitle(systemModeSubCounter=%d)",systemModeSubCounter);
					  
					  // titlescreen
 					  glBindTexture( GL_TEXTURE_2D, textureArray[textureTitle] );
					  
					  float size=15.0f;
					  // if (false)
					  [self displayFlatDirectNormal:
						
								   -size
								y: -size
								z: 0.0f 
								
								xx:size
								yy:size
						];
						
						
						// code & design.t00cg
						// music.
						// 173/373
						// size (256/128
						// textureTitleCredits
						
						glBindTexture( GL_TEXTURE_2D, textureArray[textureTitleCredits] );
						
						float partx=size*2.0f/512.0f;
						
						float creditsX=-15.0f+partx*173.0f;
						float creditsY=-21.5f+(-15.0f+partx*373.0f);
						float widthCredits=partx*256.0f;
						float heightCredits=partx*128.0f;
						
						// NSLog(@"l1neumView.drawRectIntroTitle(%f,%f,%f,%f)",creditsX,creditsY,creditsX+widthCredits,creditsX+heightCredits);
						
						if ((systemModeSub==3) || (systemModeSub==4))
						  {
							  glEnable(GL_BLEND);
							  long ipos=systemModeSubCounter;
							  if (ipos==0)
								ipos=1000;
								
							  if (systemModeSub==3)
								glColor4f( 1.0f, 1.0f, 1.0f, 1.0f-((float) ipos)/1000.0f );
							  else
								glColor4f( 1.0f, 1.0f, 1.0f, ((float) ipos)/1000.0f );
							    
						  }
						  else
						  {
								glColor4f( 1.0f, 1.0f, 1.0f, 0.0f );
						  }
						
						[self displayFlatDirectNormal:
						
								   creditsX
								y: creditsY
								z: 0.2f 
								
								xx:creditsX+widthCredits
								yy:creditsY+heightCredits
						];
						
						
						
						// GL_BLEND
						glDisable(GL_BLEND);

						// flushBuffer
					   [ [ self openGLContext ] flushBuffer ];
					   
				}

				// -------------------------------------
				// drawRectMenu
				// -------------------------------------
				- (void) drawRectMenu
				{
				  	
					 // Clear the screen and depth buffer
					   glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

					   // -----------------------
					   // reset trigo
					   // -----------------------
					   glLoadIdentity();   // Reset the current modelview matrix

					   glTranslatef( 0.0f, 0.0f, -40.0f );      // Move into screen 5 units


					  glEnable(GL_BLEND);
					  glColor4f( 1.0f, 1.0f, 1.0f, 1.0f );
					 
					  
					  // titlescreen
 					  glBindTexture( GL_TEXTURE_2D, textureArray[textureMenu] );
					  
					  float size=15.0f;
					  // if (false)
					  [self displayFlatDirectNormal:
								   -size
								y: -size
								z: 0.0f 
								
								xx:size
								yy:size
						];
												
						// code & design.t00cg
						// music.
						// 173/373
						// size (256/256
						// textureTitleCredits
						


						glBindTexture( GL_TEXTURE_2D, textureArray[textureMenuItems] );

						if (systemModeSubMode==1) glColor4f( 1.0f, 1.0f, 1.0f, 0.05f );

						
						// 200
						float partx=size*2.0f/512.0f;
						
						float creditsX=0.0f+partx*(256.0f-256.0f-35.0f);
						float creditsY=0.0f+partx*(64-256.0f);
						float widthCredits=partx*256.0f;
						float heightCredits=partx*256.0f;
											
						[self displayFlatDirectNormal:
						
								   creditsX
								y: creditsY
								z: 0.2f 
								
								xx:creditsX+widthCredits
								yy:creditsY+heightCredits
						];
						
						
						
						// selected Menu
						// ------------------
						glEnable(GL_BLEND);
						glColor4f( 1.0f, 1.0f, 1.0f, 0.7f );
						if (systemModeSubMode==1) glColor4f( 1.0f, 1.0f, 1.0f, 0.0f );
						glBindTexture( GL_TEXTURE_2D, textureArray[9] );
						
						 creditsX=0.0f+partx*(256.0f-256.0f-35.0f);
						 creditsY=0.0f+partx*(64.0f+96.0f+128.0f-256.0f-(systemModeSub)*33.0f);
						 widthCredits=partx*256.0f;
						 heightCredits=partx*33.0f;
											
						[self displayFlatDirectNormal:
						
								   creditsX
								y: creditsY
								z: 0.4f 
								
								xx:creditsX+widthCredits
								yy:creditsY+heightCredits
						];
						
						 
						// --------------------------
						// submenu ? activated ?
						// --------------------------
						if (systemModeSubMode==1)
						{
									BOOL displaySubmenu=false;

									

									// settings
									if (systemModeSub==1)
									{
										// 
										glBindTexture( GL_TEXTURE_2D, textureArray[textureMenuSubSettings] );
										displaySubmenu=true;		
									}
															
									// rulez
									if (systemModeSub==2)
									{
										glBindTexture( GL_TEXTURE_2D, textureArray[textureMenuSubRulez] );
										displaySubmenu=true;		
									}
									
									// highscore
									if (systemModeSub==3)
									{
										glBindTexture( GL_TEXTURE_2D, textureArray[textureMenuSubHighscore] );
										displaySubmenu=true;		
										
										// insert mode ?
										if (highscoreInsertMode)
										glBindTexture( GL_TEXTURE_2D, textureArray[textureMenuSubHighscoreInsert] );
										
									}


									
									// display ..
									if (systemModeSub)
									{
									
											 glColor4f( 1.0f, 1.0f, 1.0f, 1.0f );
						
											 creditsX=0.0f+partx*(-32.0f+256.0f-256.0f-35.0f-128.0f+64.0f);
											 creditsY=0.0f+partx*(64.0f+128.0f+128.0f-256.0f);
											 widthCredits=partx*512.0f;
											 heightCredits=-partx*512.0f;
																
											[self displayFlatDirectNormal:
											
													   creditsX
													y: creditsY+heightCredits
													z: 0.4f 
													
												
											
													xx: creditsX+widthCredits 
													yy: creditsY
												
											];
									
													
											// settings
											// subnavigation
											if (systemModeSub==1)
											{
												float offsetPointThis=0.3f;
												float offsetPointSize=17.0f;
												
												// window
												glBindTexture( GL_TEXTURE_2D, textureArray[1] );
											
												int posGraphics=0;
												if (systemWindowModeBig) posGraphics=1;
												
												// NSLog(@"l1neumView.systemWindowModeBig=%d posGraphics=%d",systemWindowModeBig,posGraphics);
												
												// graphics
												 creditsX=0.0f+partx*(114.0f+256.0f-256.0f-35.0f)+offsetPointThis;
												 creditsY=0.0f+partx*(5+64.0f+96.0f+128.0f-256.0f-((posGraphics+1))*33.0f);
												 widthCredits=partx*offsetPointSize;
												 heightCredits=partx*offsetPointSize;
																	
												[self displayFlatDirectNormal:
												
														   creditsX
														y: creditsY
														z: 0.4f 
														
														xx:creditsX+widthCredits
														yy:creditsY+heightCredits
												];
												

											
												// graphics
												glBindTexture( GL_TEXTURE_2D, textureArray[1] );
											
												 posGraphics=2;
												if (graphics==1) posGraphics=3;
												if (graphics==0) posGraphics=4;
												
												// graphics
												 creditsX=0.0f+partx*(114.0f+256.0f-256.0f-35.0f)+offsetPointThis;
												 creditsY=0.0f+partx*(5+64.0f+96.0f+128.0f-256.0f-((posGraphics+1))*33.0f);
												 widthCredits=partx*offsetPointSize;
												 heightCredits=partx*offsetPointSize;
																	
												[self displayFlatDirectNormal:
												
														   creditsX
														y: creditsY
														z: 0.4f 
														
														xx:creditsX+widthCredits
														yy:creditsY+heightCredits
												];
												
												// systemMusic
												int posMusicT=4;
												float offMusic=3.5f;
												if (systemMusic) 
												{ 
													offMusic=0.0f;
												}
												// graphics
												 creditsX=0.0f+partx*(114.0f+256.0f-256.0f-35.0f)+offMusic+offsetPointThis;
												 creditsY=0.0f+partx*(5+64.0f+96.0f+128.0f-256.0f-((posMusicT+1+1))*33.0f);
												 widthCredits=partx*offsetPointSize;
												 heightCredits=partx*offsetPointSize;
																	
												[self displayFlatDirectNormal:
												
														   creditsX
														y: creditsY
														z: 0.4f 
														
														xx:creditsX+widthCredits
														yy:creditsY+heightCredits
												];

												// systemEmotions
												int posET=5;
												float offE=3.5f;
												if (systemEmotions) 
												{ 
													offE=0.0f;
												}
												// emotics
												 creditsX=0.0f+partx*(114.0f+256.0f-256.0f-35.0f)+offE+offsetPointThis;
												 creditsY=0.0f+partx*(2+64.0f+96.0f+128.0f-256.0f-((posET+1+1))*33.0f);
												 widthCredits=partx*offsetPointSize;
												 heightCredits=partx*offsetPointSize;
																	
												[self displayFlatDirectNormal:
												
														   creditsX
														y: creditsY
														z: 0.4f 
														
														xx:creditsX+widthCredits
														yy:creditsY+heightCredits
												];

												
											
												// selected Menu
												// ------------------
												glEnable(GL_BLEND);
												glColor4f( 1.0f, 1.0f, 1.0f, 0.7f );
												glBindTexture( GL_TEXTURE_2D, textureArray[9] );
												
												int concretePosition=systemModeSubSettings;
												// or resize menu
												// if (systemModeSubSettings>2) concretePosition++;
												
												 creditsX=0.0f+partx*(14.0f+256.0f-256.0f-35.0f);
												 creditsY=0.0f+partx*(64.0f+96.0f+128.0f-256.0f-((concretePosition+1))*33.0f);
												 widthCredits=partx*310.0f;
												 heightCredits=partx*33.0f;
																	
												[self displayFlatDirectNormal:
												
														   creditsX
														y: creditsY
														z: 0.4f 
														
														xx:creditsX+widthCredits
														yy:creditsY+heightCredits
												];
											}
											
											
											// display highscores ?
											if (systemModeSub==3)
											{
												// display all
												
												// NSMutableString * scoreStr= [[NSMutableString alloc] initWithFormat:@"%7d",highScore[4-s]];
												int z=0;
												float beginy=-14.0f;
												for (z=0;z<10;++z)
												{   
													 glColor4f( 1.0f, 1.0f, 1.0f, 1.0f );
													
													 // display new entry
													 if (positionInHighscores!=-1)
													 {
														glColor4f( 1.0f, 1.0f, 1.0f, 0.4f );
														
														// display it 
														if (z==positionInHighscores)
														   glColor4f( 1.0f, 1.0f, 1.0f, 1.0f );
													 }
												
													NSString * strname = [hiScoresName objectAtIndex:z];
													NSMutableString * scoreStr= [[NSMutableString alloc] initWithFormat:@"%d %@",hiScoresPoints[z],strname];
													float ycoord=beginy+1.5f*(float) z;
													[self draw3DString:scoreStr x:-1.0f y:ycoord z:0.5f fontsize:1.5f];
																									
												}
											}

									
									}
						
						}
						
						
						
						
						// GL_BLEND
						glDisable(GL_BLEND);

						// flushBuffer
					   [ [ self openGLContext ] flushBuffer ];
					   
				}

				// -------------------------------------
				// drawRectGame
				// -------------------------------------
				- (void) drawRectGame
				{
					
					 // Clear the screen and depth buffer
					   glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

					   
					   // -----------------
					   // store rots
					   // -----------------
					   // 
					   xrotstore=xrot*-1.0f;
					   yrotstore=yrot*-1.0f;
					   zrotstore=zrot*-1.0f;
					   

						// color
						 glColor4f( 1.0f, 1.0f, 1.0f, 0.5f );
						 
						// ----------------------------
						// displayPlayfield
						// ----------------------------
						int z=0;
						int zz=0;
						if (debugPlayField)
						 [self debugDisplayPlayField];
						 
						 
						// -----------------------
						// display Walls
						// -----------------------
						int tpz=0;
						int used=0;
						for (tpz=0;tpz<[walls count];++tpz)
						{
							objectWall * to=[walls objectAtIndex:tpz];
							if ([to inUse])
							 ++used;
						}

						// NSLog(@"l1neumView.drawRect.walls.count=%d (used: %d)",[walls count],used);

						// ----------------------------------
						// set back
						// ----------------------------------

					   glLoadIdentity();   // Reset the current modelview matrix

					   glTranslatef( xoffset, yoffset, zoffset );      // Move into screen 5 units
					   
					   
						
						// ----------------------------------
						// background
						// ----------------------------------
						
						// generate next level	
						// in background
						
						glEnable(GL_BLEND);
						glColor4f( 1.0f, 1.0f, 1.0f, 0.5f );  

						
						float backgroundZ=-40.0f;
						
						float backgroundSize=43.0f;
						
						glBindTexture( GL_TEXTURE_2D, textureArray[textureBackground] );
						
						backgroundSize=25.0f;
						glBindTexture( GL_TEXTURE_2D, textureArray[textureGameNextLevel] );
						// limit graphics
						// used anymore ?
						/*
						if (graphics!=10)
						[self displayFlatDirectNormal:
							
								   -backgroundSize
								y: -backgroundSize
								z: backgroundZ
								
								xx:backgroundSize
								yy:backgroundSize
						];
						*/
					 
						
						// --------------------
						// slice
						// --------------------
						// limit graphics
						// glBindTexture( GL_TEXTURE_2D, textureArray[textureGameBackground] );
						if (graphics>0)
						[self displayFlatDirectNormal:
							
								   -3.0f*backgroundSize
								y: -backgroundSize
								z: backgroundZ-0.01
								
								xx:3.0f*backgroundSize
								yy:backgroundSize
						];
					    
						// glDisable(GL_BLEND);

						// --------------------
						// logo
						// --------------------
						glColor4f( 1.0f, 1.0f, 1.0f, 0.9f );  
						glBindTexture( GL_TEXTURE_2D, textureArray[textureLogo] );
						float logoSize=10.0f;
						float logoOffSetX=-21.0f;
						float logoOffSetY=17.0f+4.0f;
						
						
						[self displayFlatDirectNormal:
							
								   -2.0f*logoSize+logoOffSetX
								y: -logoSize+logoOffSetY
								z: backgroundZ+0.02
								
								xx:2.0f*logoSize+logoOffSetX
								yy:logoSize+logoOffSetY
						];
					   
						// --------------------
					    // score
						// --------------------
						// score
						glColor4f( 1.0f, 1.0f, 1.0f, 0.9f );  
						glBindTexture( GL_TEXTURE_2D, textureArray[textureScore] );
						logoOffSetX=-21.0f+37.0f;
						[self displayFlatDirectNormal:
							
								   -2.0f*logoSize+logoOffSetX
								y: -logoSize+logoOffSetY
								z: backgroundZ+0.02
								
								xx:2.0f*logoSize+logoOffSetX
								yy:logoSize+logoOffSetY
						];

						// display percent
						float positionx=-1.2f;
						float positiony=logoSize+logoOffSetY-5.5f;
						
						int percentInt=(int) (percent*100.0f);
						[self drawNumber:percentInt x:positionx y:positiony z:backgroundZ+0.03 size:4.0f];
						// smaller
						int percentFloat=((int) (percent*1000.0f))-percentInt*10;
						[self drawNumber:percentFloat x:positionx+1.8f y:positiony z:backgroundZ+0.03 size:3.0f];
						
						
						// score
						[self drawNumber:gameVarScore x:positionx+25.0f y:positiony z:backgroundZ+0.03 size:2.5f];
						
						// level
						glColor4f( 1.0f, 1.0f, 1.0f, 0.2f );  
						[self drawNumber:(gameVarLevel+1) x:-backgroundSize+14.0f y:backgroundSize-12.0f z:backgroundZ+0.03 size:7.0f];
						
						// number lifes ..
						
						// gameVarTimeout
						glColor4f( 1.0f, 1.0f, 1.0f, 1.0f );  
						[self drawNumber:gameVarTimeout x:positionx+40.0f y:positiony z:backgroundZ+0.03 size:2.5f];
						
						
						// lifes ...
						// symbol
						/*[self displayFlatDirectNormal:
							
								   -2.0f*logoSize+logoOffSetX
								y: -logoSize+logoOffSetY
								z: backgroundZ+0.02
								
								xx:2.0f*logoSize+logoOffSetX
								yy:logoSize+logoOffSetY
						];
						*/
						// count
						glColor4f( 1.0f, 1.0f, 1.0f, 1.0f );  
						[self drawNumber:gameVarLifes x:positionx+40.0f y:positiony+2.0f z:backgroundZ+0.03 size:2.5f];
						
						
						// disable here
						 glDisable(GL_BLEND);
					 
					   // -----------------------
					   // reset trigo
					   // -----------------------
					   glLoadIdentity();   // Reset the current modelview matrix

					   glTranslatef( xoffset, yoffset, zoffset );      // Move into screen 5 units

					   // Rotate on X axis
					   glRotatef( xrot, 1.0f, 0.0f, 0.0f );
					   // Rotate on Y axis
					   glRotatef( yrot, 0.0f, 1.0f, 0.0f );
					   // Rotate on Z axis
					   glRotatef( zrot, 0.0f, 0.0f, 1.0f );
						
						// ----------------------------------------
						// displayScene
						// ----------------------------------------
						if (true)
							{
							
										// --------------------
										// display all walls
										// --------------------
										int pz=0;
										for (pz=0;pz<[walls count];++pz)
										{
											objectWall * to=[walls objectAtIndex:pz];
											
											// only in use things
											if ([to inUse])
											{
												// NSLog(@"l1neumView.drawRect: %2d wallTypeId=%d",pz,[to wallTypeId]);
												
												// normal
												if ([to wallTypeId]==1)
												if ([to vertical])
												{
													glBindTexture( GL_TEXTURE_2D, textureArray[textureWallTop] );
													[self displayFlat:
															   [self convertPositionX: ([to leftCorner]).x]
															y: [self convertPositionY: ([to leftCorner]).y]
															z: [self convertPositionZ: [to z]]
															xx:[self convertPositionX: ([to rightCorner]).x]
															yy:[self convertPositionY: ([to rightCorner]).y]
															zz: [self convertPositionZ: [to zz]]
													];
												}		
												
														// normal old - down
														// limit graphics
														if (graphics>=7)
														if ([to wallTypeId]==3)
														if ([to vertical])
														{
															
															[self displayFlatExt:
																	   ([to leftCorner]).x
																	y: ([to leftCorner]).y
																	z: [to z]
																	xx:([to rightCorner]).x
																	yy:([to rightCorner]).y
																	zz: [to zz]
															];
														}
														
												// fireline
												/* firewalls
												if ([to wallTypeId]==2)
												if ([to vertical])
												{
													glBindTexture( GL_TEXTURE_2D, textureArray[2] );
													[self displayFlat:
															   [self convertPositionX: ([to leftCorner]).x]
															y: [self convertPositionY: ([to leftCorner]).y]
															z: [self convertPositionZ: [to z]]
															xx:[self convertPositionX: ([to rightCorner]).x]
															yy:[self convertPositionY: ([to rightCorner]).y]
															zz: [self convertPositionZ: [to zz]]
													];
												}
												*/
												
											}
										}
										


										
										
											// ----------------------------
											// actual floor
											// ----------------------------
											// 
											if (textureGameActualLevelEnableTransparent)
											{
												glEnable(GL_BLEND);
												glColor4f( 1.0f, 1.0f, 1.0f, textureGameActualLevelTransparent );  
												
											}
											
											
											
											for (pz=0;pz<[walls count];++pz)
											{
												objectWall * to=[walls objectAtIndex:pz];
												
												// only in use things
												if ([to inUse])
												if (![to vertical])
												// only if they are in the correct flat
												//if ([to flatNumber]==floorx)
												// in all exception: the firelines
												//if ([to wallTypeId]!=2)
												{
														glBindTexture( GL_TEXTURE_2D, textureArray[ textureGameActualLevel ] );
														
														// watereffect in level 1
														if (gameVarLevel==1)
														if (false)
														{
															if (animationCounterDirect==1)
															 textureGameActualLevel=30;
															if (animationCounterDirect==2)
															 textureGameActualLevel=31;
															if (animationCounterDirect==3)
															 textureGameActualLevel=32;
															 // not necess.
															if (animationCounterDirect==4)
															 textureGameActualLevel=31;
															if (animationCounterDirect==5)
															 textureGameActualLevel=30;
															if (animationCounterDirect==6)
															 textureGameActualLevel=57;
															 
														}
														
														
														int fx=[to leftCorner].x;
														int fy=[to leftCorner].y;
														int fxx=[to rightCorner].x;
														int fyy=[to rightCorner].y;
												  
														// display quad
														glBegin( GL_QUADS );
															// the texture coord
															float coordx=(float) (fx)/(float) (playFieldCountX);
															float coordy=(float) (fy)/(float) (playFieldCountY);
															glTexCoord2f( coordx,coordy );
															glVertex3f( [self convertPositionX: fx],  [self convertPositionY:fy], 0-3.0f );   // Top right
														   
														   
															coordx=(float) (fx)/(float) (playFieldCountX);
															coordy=(float) (fyy+1)/(float) (playFieldCountY);
															glTexCoord2f( coordx,coordy );
															glVertex3f( [self convertPositionX:fx], [self convertPositionY: fyy+1], 0-3.0f );   // Top left
														   
															coordx=(float) (fxx+1)/(float) (playFieldCountX);
															coordy=(float) (fyy+1)/(float) (playFieldCountY);
															glTexCoord2f( coordx,coordy );
															glVertex3f(  [self convertPositionX:fxx+1], [self convertPositionY:fyy+1], 0-3.0f);   // Bottom left
														   
															coordx=(float) (fxx+1)/(float) (playFieldCountX);
															coordy=(float) (fy)/(float) (playFieldCountY);
															glTexCoord2f( coordx,coordy );
															 glVertex3f(  [self convertPositionX:fxx+1], [self convertPositionY:fy],  0-3.0f );   // Bottom right
														glEnd();
												}
											}
											
											glDisable(GL_BLEND);
											 
											// -----------------------
											// display bonus boxes
											// -----------------------
											if (graphics>=7)
											for (z=0;z<[objects count];++z)
											{
											   tpObject * to=[objects objectAtIndex:z];
											  
											   // NSLog(@"%@",[to getType]);
											   
											   // size
											   NSPoint objectsizeposition=[to getPosition];
											   NSPoint objectsize=[to size];
											   float objectx=[self convertPositionX: objectsizeposition.x];
											   float objecty=[self convertPositionY: objectsizeposition.y];
											   float objectz=[self convertPositionZ: 0];
											   
											   float objectwidth=[self convertSizeX: objectsize.x];
											   float objectheight=[self convertSizeY: objectsize.y];
											   
											   
											 // enemy available 
											  if ([to status]!=0)
											  {
														
														   // bonus
														   if ([to getTypeId]==3)
														   {
																// open / close
																glBindTexture( GL_TEXTURE_2D, textureArray[textureBonus] );
																
																// passiv
																if ([to status]==3)
																{
																	// display box
																	[self displayFlat:
																			   objectx
																			y: objecty
																			z: objectz
																			xx:objectx
																			yy:objecty+objectheight
																			zz: objectz+2.0f
																	];
																	[self displayFlat:
																			   objectx+objectwidth
																			y: objecty
																			z: objectz
																			xx:objectx+objectwidth
																			yy:objecty+objectheight
																			zz: objectz+2.0f
																	];
																	[self displayFlat:
																			   objectx
																			y: objecty+objectheight
																			z: objectz
																			xx:objectx+objectwidth
																			yy:objecty+objectheight
																			zz: objectz+2.0f
																	];
																	[self displayFlat:
																			   objectx
																			y: objecty
																			z: objectz
																			xx:objectx+objectwidth
																			yy:objecty
																			zz: objectz+2.0f
																	];
																	
																	[self displayFlatDirectNormal:objectx y:objecty z:objectz-2.0f xx:objectx+objectwidth yy:objecty+objectheight ]; 
														
																}
														}
											
													}
											  }
											  
											
											  
											 glDisable(GL_BLEND); 
  
											 
																						
											// ----------------------------
											// display all object
											// ----------------------------
											// textures ...
											
											glEnable(GL_BLEND);
											glColor4f( 1.0f, 1.0f, 1.0f, 1.0f );
											
											
											glBindTexture( GL_TEXTURE_2D, textureArray[ textureShipBackground ] );
											if (
												(statusFire)
												||
												(![representation secretLine])
											 )
											glBindTexture( GL_TEXTURE_2D, textureArray[ textureShipBackgroundFireLine ] );
											
											
											float shipx=[self convertPositionX:([representation getPosition]).x];
											float shipy=[self convertPositionY:([representation getPosition]).y];
											float shipz=[self convertPositionZ:0]-0.5;
											
											float shipsize=3.0f;
											
											[self displayFlatDirect:shipx-shipsize y:shipy-shipsize z:shipz xx:shipx+shipsize yy:shipy+shipsize ]; 
											
											// -----------------------
											// shield
											// -----------------------
											// shield activated ?
											if ((shield!=0.0f) || (bonusShield>0.05f))
											{
												float fadeOut=shield;
												if (bonusShield>0.05f)
												{
													fadeOut=1.0f;
													if (bonusShield<2.0f)
														fadeOut=bonusShield/2.0f;
												}
												glColor4f( 1.0f, 1.0f, 1.0f, 1.0f );
												if (shield<1.0f) glColor4f( 1.0f, 1.0f, 1.0f, fadeOut );
												glBindTexture( GL_TEXTURE_2D, textureArray[ textureRepresentationShield ] );
												// shield	
												float sized=-0.5f;
												[self displayFlatDirect:shipx-shipsize-sized y:shipy-shipsize-sized z:shipz xx:shipx+shipsize+sized yy:shipy+shipsize+sized ]; 
												
												glColor4f( 1.0f, 1.0f, 1.0f, 1.0f );
											}
																						
											// ----------------------------
											// displayObjects
											// ----------------------------
											// in the same height
											for (z=0;z<[objects count];++z)
											{
											   tpObject * to=[objects objectAtIndex:z];
											  
											   // NSLog(@"%@",[to getType]);
											   
											   // displayFlat ...
											   // size
											   NSPoint objectsizeposition=[to getPosition];
											   NSPoint objectsize=[to size];
											   float objectx=[self convertPositionX: objectsizeposition.x];
											   float objecty=[self convertPositionY: objectsizeposition.y];
											   float objectz=[self convertPositionZ: 0];
											   
											   float objectwidth=[self convertSizeX: objectsize.x];
											   float objectheight=[self convertSizeY: objectsize.y];
											   
											   // debug
											   /*
											   if ([to status]==3)
											   {
													glBindTexture( GL_TEXTURE_2D, textureArray[ 1 ] );
													[self displayFlatDirect:objectx y:objecty z:objectz xx:objectx+objectwidth yy:objecty+objectheight ]; 
												}
												*/
											   
											 BOOL displayThis=false;
											 
											 glColor4f( 1.0f, 1.0f, 1.0f, 1.0f );
											 
											 // enemy available 
											  if ([to status]!=0)
											  {
														   // the representation
														   if ([to getTypeId]==1)
														   {
																glBindTexture( GL_TEXTURE_2D, textureArray[ textureRepresentation ] );
				
																[self displayFlatDirect:objectx-objectwidth/2 y:objecty-objectheight/2 z:objectz xx:objectx+objectwidth/2 yy:objecty+objectheight/2 ]; 
																
																displayThis=false;
															}  
														
															
														   // bigBoss
														   if ([to getTypeId]==2)
														   {
																int enemyB=animationCounterDirect;
																if (enemyB==3) enemyB=2;
																if (enemyB==4) enemyB=1;
																if (enemyB==5) enemyB=0;
																if (enemyB==6) enemyB=0;
																
																glBindTexture( GL_TEXTURE_2D, textureArray[ textureEnemyBigBoss+enemyB] );
																displayThis=true;
																
															}
														
														   // bonus
														   if ([to getTypeId]==3)
														   {
																glColor4f( 1.0f, 1.0f, 1.0f, 1.0f );
																
																// open / close
																glBindTexture( GL_TEXTURE_2D, textureArray[textureBonus] );
																
																
																// activated
																if ([to status]==2)
																{
																	// display the contents ..
																	int dpix=[to typeSub];
																	if (dpix<0) dpix=0;
																	if (dpix>9) dpix=9;
																	glBindTexture( GL_TEXTURE_2D, textureArray[textureBonusBase+dpix] );
																	
																																		// scale
																	float scale=(1.0f/([to timerMax]))*[to timer];
																	// blend out
																	glColor4f( 1.0f, 1.0f, 1.0f, scale );
																										
																	// re-size
																	objectx=objectx-1.0f;
																	objecty=objecty-1.0f;
																	objectwidth=objectwidth+2.0f;
																	objectheight=objectheight+2.0f;
																	
																	// go down
																	// objectz=objectz-([to timerMax]-[to timer]);
								
																	
																	// blend out ...
																}
																		
																displayThis=true;
																
															}
														
														  // enemy
														   if ([to getTypeId]==4)
														   {
																glBindTexture( GL_TEXTURE_2D, textureArray[ textureEnemy ] );
																displayThis=true;
																
																// status == 2 ?
																// re-size
																float timert=[to timer];
																if (timert>0.0f)
																{
																	float ti=10.0f-timert;
																	objectz=-ti/2.0f;
																	/*
																	objectx=objectx-ti;
																	objecty=objecty-ti;
																	objectwidth=objectwidth+2.0f*ti;
																	objectheight=objectheight+2.0f*ti;
																	
																	
																	if (timert<3.0f)
																	 glColor4f( 1.0f, 1.0f, 1.0f, timert/3.0f );
																    */
																}
															}
															
															// enemyfly = shoot
														   if (([to getTypeId]==4) && ([to flyingFlag]))
														   {
																glBindTexture( GL_TEXTURE_2D, textureArray[ textureEnemyFly ] );
																displayThis=true;
																
																// objectz=1.5f;
																// objectwidth=5.0f;
															}
														
															if (displayThis)
															 [self displayFlatDirectNormal:objectx y:objecty z:objectz xx:objectx+objectwidth yy:objecty+objectheight ]; 
														   
												
															
															// NSLog(@"l1neumView.drawRectGame.[%d] typeId=%d   flayFlag=%d",z,[to getTypeId],[to flyingFlag]);
												}
													
											}
											
											// --------------------
											// textureHunter
											// --------------------
											// display red line
											glEnable(GL_BLEND);
											glColor4f( 1.0f, 1.0f, 1.0f, 0.7f );  

											glBindTexture( GL_TEXTURE_2D, textureArray[ textureHunter ] );
													
											// display it
											if ([enemyRunner1 status]==3)
											{
												float enx=[self convertPositionX:([enemyRunner1 getPosition]).x];
												float eny=[self convertPositionY:([enemyRunner1 getPosition]).y];
												float enz=[self convertPositionZ:0]-0.0f;
												
												float esize=1.5f; 
												[self displayFlatDirect:enx-esize y:eny-esize z:enz xx:enx+esize yy:eny+esize ]; 
											}
											
											// display it
											if ([enemyRunner2 status]==3)
											{
												float enx=[self convertPositionX:([enemyRunner2 getPosition]).x];
												float eny=[self convertPositionY:([enemyRunner2 getPosition]).y];
												float enz=[self convertPositionZ:0]-0.0f;
												
												float esize=1.5f; 
												[self displayFlatDirect:enx-esize y:eny-esize z:enz xx:enx+esize yy:eny+esize ]; 
											}
											
											// ------------------------
											// fireline
											// ------------------------
											// display red line
											glEnable(GL_BLEND);
											glColor4f( 1.0f, 1.0f, 1.0f, 0.5f );  

											glBindTexture( GL_TEXTURE_2D, textureArray[ textureShipBackground ] );
											if (
												(statusFire)
												||
												(![representation secretLine])
											 )
											glBindTexture( GL_TEXTURE_2D, textureArray[ textureShipBackgroundFireLine ] );
											
											// -----------------------
											// firelineDisplay
											// -----------------------
											int everyMax=1;
											int everyX=0;
											if (graphics==0) everyMax=10;
											
											// display fireline 
											int z=0;
											int zz=0;
											for (z=2;z<playFieldCountX-1;++z)
											 for (zz=2;zz<playFieldCountY-1;++zz)
											  {
											
												BOOL displayThisPixel=true;
												
												// graphics ?
												if (graphics==0) 
												{   displayThisPixel=false;
													everyX++;
													if (everyX>everyMax) 
													{
														everyX=0;
														displayThisPixel=true;
														
													}
												}
												
												if (displayThisPixel)
												if (playField[z][zz]==3)
												{
													// display it
													float dx=[self convertPositionX:z];
													float dy=[self convertPositionY:zz];
													float dz=[self convertPositionZ:0];
													
													float dsize=0.25f; 
													
													/*
														// special
														// version 1.0
														if ((z%10==0) || (zz%50==0))
															dsize=1.00f;
														// uh nice effect
														// dz=-0.4f+((float) (z))*0.1f;
														dz=-0.4f+((float) (z))*0.001f;
													*/
													if (
															((playField[z-1][zz]==3) && (playField[z][zz-1]==3)) 
														 ||	((playField[z-1][zz]==3) && (playField[z][zz+1]==3)) 
														 ||	((playField[z+1][zz]==3) && (playField[z][zz-1]==3)) 
														 ||	((playField[z+1][zz]==3) && (playField[z][zz+1]==3)) 
													   )
													 {
														dsize=1.0f;
													 }  
													 
													dz=dz+((float) (z+zz))*0.0001f;
													[self displayFlatDirect:dx-dsize y:dy-dsize z:dz xx:dx+dsize yy:dy+dsize ]; 
						
													/*
													dz=dz+((float) (z+zz))*0.005f;
													[self displayFlatDirect:dx-dsize y:dy-dsize z:dz xx:dx+dsize yy:dy+dsize ]; 
													*/
												}
											  } 
											
											
											// -----------------
											// paused ?
											// ----------------- 
											if (systemModeSub==2)
											{
												glColor4f( 1.0f, 1.0f, 1.0f, 0.9f );  
												if (systemModeSubMode==0)
												  glBindTexture( GL_TEXTURE_2D, textureArray[ texturePaused ] );
											    else
												  glBindTexture( GL_TEXTURE_2D, textureArray[ texturePausedExit ] );
											   int confirmy=50; 
											   [self displayFlatDirectNormal:[self convertPositionX:0] y:[self convertPositionY:confirmy] z:[self convertPositionZ:1] xx:[self convertPositionX:399] yy:[self convertPositionY:confirmy+80] ];
											}
											
											// 
											// -----------------
											// game over
											// ----------------- 
											if (systemModeSub==5)
											{
												glColor4f( 1.0f, 1.0f, 1.0f, 0.9f );  
												  glBindTexture( GL_TEXTURE_2D, textureArray[ textureGameOver ] );
											   int confirmy=50; 
											   [self displayFlatDirectNormal:[self convertPositionX:0] y:[self convertPositionY:confirmy] z:[self convertPositionZ:1] xx:[self convertPositionX:399] yy:[self convertPositionY:confirmy+80] ];
											}
											
											// 
											// -----------------
											// game end
											// ----------------- 
											if (systemModeSub==6)
											{
												glColor4f( 1.0f, 1.0f, 1.0f, 0.9f );  
												  glBindTexture( GL_TEXTURE_2D, textureArray[ textureFinished ] );
											   int confirmy=50; 
											   [self displayFlatDirectNormal:[self convertPositionX:0] y:[self convertPositionY:confirmy] z:[self convertPositionZ:1] xx:[self convertPositionX:399] yy:[self convertPositionY:confirmy+80] ];
											}
											
											
											// disable blend
											glDisable(GL_BLEND);

						}
							
    

						

						// ----------------------------------
						// logo
						// ----------------------------------


					   glLoadIdentity();   // Reset the current modelview matrix

					   glTranslatef( xoffset, yoffset, zoffset );      // Move into screen 5 units
					   
						
						// generate a planet 	
						// in background
						
						glEnable(GL_BLEND);

						// logoBackground
						// textureLogoBackground
				/*
						glColor4f( 1.0f, 1.0f, 1.0f, 1.0f );   // Full brightness, 50% alpha

						float logoLeft=23.0f;
						
						float frontLogoBackground=-3.0f;
						float frontSizeBackground=4.0f;	
						glBindTexture( GL_TEXTURE_2D, textureArray[textureLogoBackground] );
						[self displayFlatDirect:
							
								   logoLeft+1.0f+frontSizeBackground
								y: -frontSizeBackground*4
								z: frontSizeBackground-0.5
								
								xx:logoLeft+1.0f-frontSizeBackground
								yy:frontSizeBackground*4
						];

						// logo
						glColor4f( 1.0f, 1.0f, 1.0f, 1.0f );   // Full brightness, 50% alpha
						float frontLogo=-3.0f;
						float frontSize=4.0f;	
						glBindTexture( GL_TEXTURE_2D, textureArray[textureLogo] );
						[self displayFlatDirect:
							
								   logoLeft+frontSize
								y: -frontSize*2-6.0f
								z: frontSize
								
								xx:logoLeft-frontSize
								yy:frontSize*2-6.0f
						];

					*/



						glDisable(GL_BLEND);

						
						
						// function ... 
						
						// generate box-flats ...
						// -|
						// ===|
						// ==|
						
								/*
							 glBegin( GL_POLYGON );
							 
								glVertex3f(0.0f, 0.0f, 0.0f);
								glVertex3f(5.0f, 0.0f, 0.0f);
								glVertex3f(5.0f, 5.0f, 0.0f);
								
								glVertex3f(4.0f, 5.0f, 0.0f);

								glVertex3f(4.0f, 8.0f, 0.0f);
								glVertex3f(3.0f, 8.0f, 0.0f);
								
								glVertex3f(3.0f, 5.0f, 0.0f);
								
								
								glVertex3f(0.0f, 5.0f, 0.0f);
								
								
							 glEnd();
							 */
								 
							
						
						
						

					   [ [ self openGLContext ] flushBuffer ];

						// debug
					   if (debugRotateF)
					   {
							xrot += 0.3f;
							yrot += 0.2f;
							zrot += 0.4f;
						}

					   // slow rotation
					   /*
					   xrot += 0.2f;
					   yrot += 0.20f;
					   zrot += 0.18f;	
						*/

				
				}
				
				
						// drawNumber
						- (void) drawNumber: (long)number x: (float) x y:(float)y z:(float)z size:(float) size
						{
							// textureNumber
							// pot
							int pot=0;
							
							do  
							{
							
								int thisnumber=(int) (number%10);
								if (thisnumber<0) thisnumber=thisnumber*(-1);
								number=number/10;
								
								// NSLog(@"l1neumView.drawNumber-%d",thisnumber);
								
								if (thisnumber<0) thisnumber=0;
								if (thisnumber>9) thisnumber=9;
								
								glBindTexture( GL_TEXTURE_2D, textureArray[ textureNumber+thisnumber ] );
								// displayFlatDirectNormal
								[self displayFlatDirectNormal:
								
									   x-size
									y: y
									z: z
									
									xx:x
									yy:y+size
								];
								
								// go back
								x=x-size*0.5f;
								if (thisnumber==0) x=x+0.1f;
								if (thisnumber==1) x=x+0.1f;
								
								// ... spacer .. ever a bcd efg
								if ((pot+1)%3==0)
								  x=x-0.6f;
								// add pot
								pot=pot+1;
							}
							while (number!=0);
							
						}
				

				// generateBoxFloor
				- (BOOL) generateBoxFloor
				{
				  
				  // clear ..
				  int pz=0;
				  for (pz=0;pz<[walls count];++pz)
				  {
						objectWall * to=[walls objectAtIndex:pz];
						
						// only in use things
						if ([to inUse])
						if (![to vertical])
						{
						    [to setInUse:false];
						}
				  }
				
				
				  // NSLog(@"l1neumView.generateBoxFloor");
				  // 0 --> 1
				  // 2 --> ?
				  // convert 
				  
				  BOOL nextBoxF=true;
				  do
				  {
				     nextBoxF=[self generateNextBoxFloor];
				  }
				  while(nextBoxF);
				  
				 				  
				  // reverse back   
				  int z=0;
				  int zz=0;
				  for (z=2;z<playFieldCountX;++z)
					 for (zz=2;zz<playFieldCountY;++zz)
					 {
						if (playField[z][zz]==7)
						 playField[z][zz]=0;
					 
						if (playField[z][zz]==8)
						 playField[z][zz]=3;
					 
					 }
				}
				
							// generateNextBoxFloor
							- (BOOL) generateNextBoxFloor
							{
								// NSLog(@"l1neumView.generateNextBoxFloor");
								int fx=-1;
								int fy=-1;
							
								// search first ..
								int z=0;
								int zz=0;
								for (z=0;z<playFieldCountX;++z)
								{
								  BOOL breakf=false;
								  
									 for (zz=0;zz<playFieldCountY;++zz)
									 {
									
										 // used ..
										 if (playField[z][zz]==0)
										 {
											// NSLog(@"l1neumView.generateNextBoxFloor.checkpoint_0.fx=%d,fy=%d",z,zz);
											
											fx=z;
											fy=zz;
											
											breakf=true;
											break;
										 }
									 }
									if (breakf) break;
								}
								 
								 // check if found ..
								 if ((fx!=-1)&&(fy!=-1))
								 {
									// NSLog(@"l1neumView.generateNextBoxFloor.checkpoint_1.fx=%d,fy=%d",fx,fy);
									
									// let's make a box there :-)
									
									int width=-1;
									int height=-1;
									
									// x-coords
									// ------o
									for (z=0;z<playFieldCountX;++z)
									{
										width=z;
										height=0;
											
										 BOOL breakf=false;
										
									 
										// horizontal
										if (playField[fx+z][fy+height]!=0)
										{
											break;
										}
										
									}
									
									
									// y-coords
									//		 |
									// ------o
									
									for (z=0;z<playFieldCountY;++z)
									{
										// width=z;
										height=z;
											
										 BOOL breakf=false;
										
										 for (zz=0;zz<width;++zz)
										 {
											// horizontal
											if (playField[fx+zz][fy+height]!=0)
											{
												breakf=true;
												break;
											}
											
										 }
										 
										 if (breakf) break;
									}
									
									
									  // do a quad
									 if (width!=-1)
									  if (height!=-1)
									  {
											// set flags ...
											// 0-> 7
											// 3-> 8
											for (z=fx;z<(fx+width+1);++z)
											 for (zz=fy;zz<(fy+height+1);++zz)
											 {
												if (playField[z][zz]==0)
												 playField[z][zz]=7;
											 
												if (playField[z][zz]==3)
												 playField[z][zz]=8;
											 
											 }
											
											// -
											
											// NSLog(@"l1neumView.generateNextBoxFloorAt(%d,%d)Size(%d,%d)",fx,fy,width,height);
									  
											// addObjectFloor
											[self addObjectFloor:fx y:fy xx:fx+width yy:fy+height type:0];
									  
									  }
									
									// return ok
									return true;
								 }
								 else
								 {
									return false;
								 }
							
							}


				// convertPositionX
				- (float) convertPositionX:(int) arg
				{
					// return (float)arg;
					return ((float)arg-((float) playFieldCountX)/2)*scalePlayFieldX;
				}
			
				// convertPositionY
				- (float) convertPositionY:(int) arg
				{
					// return (float)arg;	
					return ((float)arg-((float) playFieldCountY)/2)*scalePlayFieldY;	
				}
				
				// convertPositionZ
				- (float) convertPositionZ:(int) arg
				{
					return (float)arg*scalePlayFieldZ;	
				}
				

				// convertSizeX
				- (float) convertSizeX:(int) arg
				{
					return (float)arg*scalePlayFieldX;	
				}

				// convertSizeY
				- (float) convertSizeY:(int) arg
				{
					return (float)arg*scalePlayFieldY;	
				}

				// convertSizeZ
				- (float) convertSizeZ:(int) arg
				{
					return (float)arg*scalePlayFieldZ;	
				}				      
				
	// debugDisplayPlayField
	- (void) debugDisplayPlayField
	{
		int z=0;
		int zz=0;
		for (z=0;z<playFieldCountX;++z)
		 for (zz=0;zz<playFieldCountY;++zz)
		 {
		
			 // used ..
			 if (playField[z][zz]==1)
			 {
				glBindTexture( GL_TEXTURE_2D, textureArray[ 1 ] );
				[self displayCubeSize:[self convertPositionX: z] y:[self convertPositionY: zz] z:0.0f size:0.25f];

				// glBindTexture( GL_TEXTURE_2D, textureArray[ 0 ] );
				// [self displayCubeSize:(float) z y:(float) zz z:-0.7f size:0.25f];
			 }
			
			// the line around
			if (playField[z][zz]==2)
			 {
				glBindTexture( GL_TEXTURE_2D, textureArray[ 2 ] );
				[self displayCubeSize:[self convertPositionX: z] y:[self convertPositionY: zz] z:0.0f size:0.25f];
			 }
			 
			 // the line of me
			 if (playField[z][zz]==3)
			 {
				glBindTexture( GL_TEXTURE_2D, textureArray[ 3 ] );
				[self displayCubeSize:[self convertPositionX: z] y:[self convertPositionY: zz] z:0.0f size:0.25f];
			 }
			 
			 // inlines (like castles and things no endpoint)
			 if (playField[z][zz]==4)
			 {
				glBindTexture( GL_TEXTURE_2D, textureArray[ 4 ] );
				[self displayCubeSize:[self convertPositionX: z] y:[self convertPositionY: zz] z:0.0f size:0.25f];
			 }
			 
			  if (playField[z][zz]==5)
			 {
				glBindTexture( GL_TEXTURE_2D, textureArray[ 5 ] );
				[self displayCubeSize:[self convertPositionX: z] y:[self convertPositionY: zz] z:0.0f size:0.25f];
			 }
			 
			 
		 }
	}			
			

	// displayCube
	- (void) displayCube:(float) t y:(float)tt z:(float) ttt
	{
		[self displayCubeSize:t y:tt z:tt size:0.25f];
	}

	// displayCubeSize
	- (void) displayFlat:(float)tx y:(float)ty z:(float)tz xx:(float)txx yy:(float)tyy  zz:(float)tzz
	{
			float size=0.25f;
	
			glBegin( GL_QUADS );
		
		   glTexCoord2f( 0.01f, 0.01f );
		   glVertex3f(  txx,  tyy, - tzz );   // Top right
		
			glTexCoord2f( 0.01f, 1.0f );
		   glVertex3f( txx,  tyy, -tz );   // Top left
		   
		   glTexCoord2f( 1.0f, 1.0f );
		   glVertex3f( tx, ty, -tz);   // Bottom left
		   
		   glTexCoord2f( 1.0f, 0.01f );
		   glVertex3f(  tx, ty,  -tzz );   // Bottom right
	   
		  
		   
		   glEnd();
	}
	
	// displayFlatDirect
	- (void) displayFlatDirect:(float)tx y:(float)ty z:(float)tz xx:(float)txx yy:(float)tyy  
	{
	
			glBegin( GL_QUADS );
		
		   glTexCoord2f( 0.01f, 0.01f );
		   glVertex3f(  tx,  ty, tz );   // Top right
		
			glTexCoord2f( 0.01f, 1.0f );
		   glVertex3f( txx,  ty, tz );   // Top left
		   
		   glTexCoord2f( 1.0f, 1.0f );
		   glVertex3f( txx, tyy, tz);   // Bottom left
		   
		   glTexCoord2f( 1.0f, 0.01f );
		   glVertex3f(  tx, tyy,  tz );   // Bottom right
	   
		  
		   
		   glEnd();
	}

	// displayFlatDirectNormal
	- (void) displayFlatDirectNormal:(float)tx y:(float)ty z:(float)tz xx:(float)txx yy:(float)tyy  
	{
	
			glBegin( GL_QUADS );
		
		/*
		   glTexCoord2f( 0.01f, 0.01f );
		   glVertex3f(  tx,  ty, tz );   // Top right
		
		   glTexCoord2f( 1.0f, 0.01f );
		   glVertex3f( txx,  ty, tz );   // Top left
		   
		   glTexCoord2f( 1.0f, 1.0f );
		   glVertex3f( txx, tyy, tz);   // Bottom left
		   
			glTexCoord2f( 0.01f, 0.01f );
		   glVertex3f(  tx, tyy,  tz );   // Bottom right
	   */
		   glTexCoord2f( 0.01f, 0.01f );
		   glVertex3f(  tx,  ty, tz );   // Top right
		
			glTexCoord2f( 1.00f, 0.01f );
		   glVertex3f( txx,  ty, tz );   // Top left
		   
		   glTexCoord2f( 1.0f, 1.0f );
		   glVertex3f( txx, tyy, tz);   // Bottom left
		   
		   glTexCoord2f( 0.01f, 1.0f );
		   glVertex3f(  tx, tyy,  tz );   // Bottom right
		  
		   
		   glEnd();
	}

	
	// display flat with big texture behind
	- (void) displayFlatExt:(int)tx y:(int)ty z:(int)tz xx:(int)txx yy:(int)tyy  zz:(int)tzz
	{
			float size=0.25f;
	
			int directionWall=0;
	
			if (tx==txx)
			 directionWall=1;
	
			glBindTexture( GL_TEXTURE_2D, textureArray[textureWallFront] );
			if (directionWall==0) glBindTexture( GL_TEXTURE_2D, textureArray[textureWallSide] );
	
			glBegin( GL_QUADS );
			
		
			float coordx=(float) tx/(float) (playFieldCountX);
			float coordy=(float) ty/(float) (playFieldCountY);
			float coordz=(float) (tz-heightTopFloor)/(float) ((flat+1)*heightFloor);

			float coordxx=(float) txx/(float) (playFieldCountX);
			float coordyy=(float) tyy/(float) (playFieldCountY);
			float coordzz=(float) (tzz-heightTopFloor)/(float) ((flat+1)*heightFloor);
			
			// glTexCoord2f( 0.01f, 0.01f );
		    if (directionWall==0) glTexCoord2f( coordxx,coordzz );		    
		    if (directionWall==1) glTexCoord2f( coordyy,coordzz );		    
			glVertex3f(  [self convertPositionX: (txx)],  [self convertPositionY: (tyy)], -[self convertPositionZ: (tzz)]);   // Top right
		
			// glTexCoord2f( 0.01f, 1.0f );
		    if (directionWall==0) glTexCoord2f( coordxx,coordz );		    
		    if (directionWall==1) glTexCoord2f( coordyy,coordz );		    
		   glVertex3f([self convertPositionX: (txx)],  [self convertPositionY: (tyy)], -[self convertPositionZ: (tz)]);   // Top left
		   
		   // glTexCoord2f( 1.0f, 1.0f );
		    if (directionWall==0) glTexCoord2f( coordx,coordz );		    
		    if (directionWall==1) glTexCoord2f( coordy,coordz );		    
		   glVertex3f(  [self convertPositionX: (tx)],  [self convertPositionY: (ty)], -[self convertPositionZ: (tz)]);   // Bottom left
		   
		   // glTexCoord2f( 1.0f, 0.01f );
		    if (directionWall==0) glTexCoord2f( coordx,coordzz );		    
		    if (directionWall==1) glTexCoord2f( coordy,coordzz );		    
		   glVertex3f(  [self convertPositionX: (tx)],  [self convertPositionY: (ty)], -[self convertPositionZ: (tzz)] );   // Bottom right
	   
		  
		   
		   glEnd();
	}

	
	// displayCubeSize
	- (void) displayCubeSize:(float) t y:(float)tt z:(float) ttt size:(float)size
	{
			// float size=0.25f;
	
			glBegin( GL_QUADS );
		   // Front face
		   glTexCoord2f( 0.0f, 0.0f );
		   glVertex3f( t, tt,  ttt+size );   // Bottom left
		   glTexCoord2f( 1.0f, 0.0f );
		   glVertex3f(  t+size, tt,  ttt+size );   // Bottom right
		   glTexCoord2f( 1.0f, 1.0f );
		   glVertex3f(  t+size,  tt+size,  ttt+size );   // Top right
		   glTexCoord2f( 0.0f, 1.0f );
		   glVertex3f( t,  tt+size,  ttt+size );   // Top left


		   // Back face
		   glTexCoord2f( 1.0f, 0.0f );
		   glVertex3f( t, tt, ttt );   // Bottom right
		   glTexCoord2f( 1.0f, 1.0f );
		   glVertex3f( t,  tt+size, ttt );   // Top right
		   glTexCoord2f( 0.0f, 1.0f );
		   glVertex3f(  t+size,  tt+size, ttt );   // Top left
		   glTexCoord2f( 0.0f, 0.0f );
		   glVertex3f(  t+size, tt, ttt );   // Bottom left

		   // Top face
		   glTexCoord2f( 0.0f, 1.0f );
		   glVertex3f( t,  tt+size, ttt );   // Top left
		   glTexCoord2f( 0.0f, 0.0f );
		   glVertex3f( t,  tt+size,  ttt+size );   // Bottom left
		   glTexCoord2f( 1.0f, 0.0f );
		   glVertex3f(  t+size,  tt+size,  ttt+size );   // Bottom right
		   glTexCoord2f( 1.0f, 1.0f );
		   glVertex3f(  t+size,  tt+size, ttt );   // Top right

		   // Bottom face
		   glTexCoord2f( 1.0f, 1.0f );
		   glVertex3f( t, tt, ttt );   // Top right
		   glTexCoord2f( 0.0f, 1.0f );
		   glVertex3f(  t+size, tt, ttt );   // Top left
		   glTexCoord2f( 0.0f, 0.0f );
		   glVertex3f(  t+size, tt, ttt+ size );   // Bottom left
		   glTexCoord2f( 1.0f, 0.0f );
		   glVertex3f( t, tt,  ttt+size );   // Bottom right
/*
		   // Right face
		   glTexCoord2f( t+size, 0.0f );
		   glVertex3f(  1.0f, tt-size, ttt-size );   // Bottom right
		   glTexCoord2f( t+size, 1.0f );
		   glVertex3f(  1.0f,  tt+size, ttt-size );   // Top right
		   glTexCoord2f( 0.0f, 1.0f );
		   glVertex3f(  t+size,  tt+size,  ttt+size );   // Top left
		   glTexCoord2f( 0.0f, 0.0f );
		   glVertex3f(  t+size, tt-size, ttt+ size );   // Bottom left

		   // Left face
		   glTexCoord2f( 0.0f, 0.0f );
		   glVertex3f( t+size, tt-size, ttt-size );   // Bottom left
		   glTexCoord2f( 1.0f, 0.0f );
		   glVertex3f( t+size, tt-size, ttt+ size);   // Bottom right
		   glTexCoord2f( 1.0f, 1.0f );
		   glVertex3f( t-size,  tt+size, ttt+ size );   // Top right
		   glTexCoord2f( 0.0f, 1.0f );
		   glVertex3f( t-size,  tt+size, ttt-size );   // Top left
		   
*/
			glEnd();
	}

// full screen ?
- (BOOL) isFullScreen
{
   return runningFullScreen;
}


// dealloc
- (void) dealloc
{
   if( runningFullScreen )
      [ self switchToOriginalDisplayMode ];
   [ originalDisplayMode release ];
}


// ----------------------
// reset game
// ----------------------
- (void) resetGame
{
   
   // reset vars
   gameVarLevel=0;
   gameVarLifes=3;
   gameVarScore=0;
   timeOutCounter=0;
   	
		// scores for ...
		gameVarScoreKilledEnemy=500;

	textureGameActualLevel=4;
	gameVarLevel=-1;
	
	// testing
	// start here
	// gameVarLevel=6;

	// last level
	gameVarEndLevel=8;
}


// ----------------------
// reset level
// ----------------------
- (void) resetLevel
{
	flat=0;

	dotesCount=0;
	
   // disable permanent rotation
   debugRotateF=false;
   
   // rotation view
   xrot=originxrot;
   yrot=originyrot; // 0.0f
   zrot=originyrot;
   
   // interface
	 statusMove1=false;
	 statusMove2=false;
	 statusMove3=false;
	 statusMove4=false;
	 
	 statusFire=false;
   
   
	// 
	int z=0;
	int zz=0;
	
	// clear field
	for (z=0;z<playFieldCountX;++z)
	  for (zz=0;zz<playFieldCountY;++zz)
	    playField[z][zz]=0;
	
	// make a some lines
	// -----
	// -----
	for (zz=0;zz<playFieldCountY;++zz)
	 {
		playField[zz][0]=1;
		playField[zz][playFieldCountY-1]=1;
		
		// the line
		playField[zz][1]=2;
		playField[zz][playFieldCountY-2]=2;
	 }

	// |	|
	// |	|
	for (zz=1;zz<playFieldCountY-1;++zz)
	 {
		playField[0][zz]=1;
		playField[playFieldCountY-1][zz]=1;
		
		// the line
		playField[1][zz]=2;
		playField[playFieldCountY-2][zz]=2;
	 }

	// walls
	int pz=0;
	for (pz=0;pz<[walls count];++pz)
	{
		objectWall * to=[walls objectAtIndex:pz];
		[to setInUse:false];
		
	}
	
	// reset all enemies
	// +disable bonus
	int dz=0;
	for (dz=0;dz<[objects count];++dz)
	{
		tpObject * to=[objects objectAtIndex:dz];
	
		// resetTimer
		[to setTimer:0.0f];
		
		
		
		// bonus
		if ([to typeId]==3)
		{
			[to setStatus:0];
			// envelope ?
			// [to setStatus:0];
		}
		
		// to ...
		if ([to typeId]==4)
		{
			[to setStatus:0];
			
			// no killed ..
			// tboEnemy * tob=[objects objectAtIndex:dz];
			[to setKilledFlag:false];
		}
	}
	
	// ----------------
	// enemyBoss
	// ----------------
	// reset size enemyBoss
	[enemyBoss setSize:NSMakePoint(60,60)];
	[enemyBoss setPosition:NSMakePoint(playFieldCountX/2,playFieldCountY/2)];
    [enemyBoss setPosition: NSMakePoint(SSRandomIntBetween(15,playFieldCountX/2),SSRandomIntBetween(15,playFieldCountY/2))];


	enemyShootType=0;
		
		
	// slow
	[enemyRunner1 setStatus:0];
	[enemyRunner2 setStatus:0];
	
	// reset the runners
	[self resetRunners];

	// ----------------
	// bonus
	// ----------------
	// reset bonus ...
	bonusShield=0.0f;
	bonusTimeout=0.0f;
	bonusSpeedup=0.0f;
	
	// timeout
	gameVarTimeout=600;
	
	// percent
	percent=0.0f;
	
	// generateWallsForDisplay
	[self generateWallsForDisplay];
}


// ------------------------------
// doGameCircle
// ------------------------------
- (void) doGameCircle
{
	// --------------
	// animation
	// --------------
	
		animationCounter++;
		if (animationCounter>50)
		{
			animationCounter=0;
			
			animationCounterDirect++;
			// NSLog(@"l1neumView.animationCounterDirect=%d",animationCounterDirect);
		
			
			// animationReverse ?
			if (!animationReverse)
			{
			  if (animationCounterDirect>2)
				animationCounterDirect=0;
			}
			else
			{
			  if (animationCounterDirect>5)
				animationCounterDirect=0;
			}
		}
	
	// let's count down .. 
	systemModeSubCounter=systemModeSubCounter-1;
	if (systemModeSubCounter<0) systemModeSubCounter=0;
	
	// timer down
	menuTimer=menuTimer-0.1f;
	if (menuTimer<0.0f)
	 menuTimer=0.0f;
	
	// ------------------
	// game intro
	// = titlescreen
	// ------------------
	if (systemMode==0)
	{
		// start music ..
		if (systemModeSub==0)
		{
			// play
			GoToBeginningOfMovie ([musicTitleTheme QTMovie]);
			
			if (soundTitlePlay)
			 StartMovie ([musicTitleTheme QTMovie]);
			
			systemModeSub=1;
			systemModeSubCounter=1000;
		}
		
		// blend in ..
		if (systemModeSub==1)
		{
			// count down ..
			if (systemModeSubCounter==0)
			{
				systemModeSub=2;
				systemModeSubCounter=2000;
			}
			
		}
		
		// blend in code&design by ..
		if (systemModeSub==2)
		{
			// count down ..
			if (systemModeSubCounter==0)
			{
				systemModeSub=3;
				systemModeSubCounter=1000;
			}
		
		}
		
		// blend out code&design by ..
		if (systemModeSub==3)
		{
			// count down ..
			if (systemModeSubCounter==0)
			{
				systemModeSub=4;
				systemModeSubCounter=1000;
			}
			
		}
		
		// loop it ..
		if (systemModeSub==4)
		{
			// count down ..
			if (systemModeSubCounter==0)
			{
				systemModeSub=2;
				systemModeSubCounter=1000;
				
				// NSLog(@"l1neumView.doGameCircle:systemModeIntroAutomaticNext=%d",systemModeIntroAutomaticNext);
				
				// automatic go on ?
				++systemModeIntroAutomaticNext;
				if (systemModeIntroAutomaticNext>5)
				 {
					// systemMode ..
					systemModeSub=10;
					systemModeSubCounter=1000;
				  }
			}
			
		}
		
		// slow out
		if (systemModeSub==10)
		{
			// count down ..
			if (systemModeSubCounter==0)
			{
				systemMode=1;
				systemModeSub=0;
			}
		}
			
		
		
	}
	// ------------------
	// menu
	// ------------------
	if (systemMode==1)
	{
		// restart music
		// play loop
		if (IsMovieDone([musicTitleTheme QTMovie]))
		{
			NSLog(@"l1neumView.doGameCircle.startMenuMusic.loop");
		   // start all ..
		   GoToBeginningOfMovie ([musicTitleTheme QTMovie]);
		   if (soundTitlePlay)
			StartMovie ([musicTitleTheme QTMovie]);
		}
		
		// stop title theme
		if (!IsMovieDone([musicInGame QTMovie]))
		{
			StopMovie([musicInGame QTMovie]);
		}
	}
	
	
	
	// ------------------
	// game mode
	// ------------------
	if (systemMode==2)
	{
		
	
		// stop title theme
		if (!IsMovieDone([musicTitleTheme QTMovie]))
		{
			StopMovie([musicTitleTheme QTMovie]);
		}
		
		// loop ingamemusc
		// restart music
		// play loop
		if (IsMovieDone([musicInGame QTMovie]))
		if (systemMusic)
		{
		   // start all ..
		   GoToBeginningOfMovie ([musicInGame QTMovie]);
		   StartMovie ([musicInGame QTMovie]);
		}
		
		// ingame   
		if (systemModeSub==1)
		{
			// doEmotions 
			if (systemEmotions)
			{
				[self doEmotions];
			}
			// 
			else
			{
				   
				   xrot=originxrot;
				   yrot=originyrot; // 0.0f
				   zrot=originyrot;
				 
			}
			
			// doThreadObjects
			if (bonusTimeout<0.05f)
			{
				[self doThreadObjects];
				
				// timeout ? > faster ...
				// 2 x 
				if (gameVarTimeout<4)
					[self doThreadObjects];
			}
			
			// timeout (shield in volfied)
			timeOutCounter++;
			if (timeOutCounter>50)
			  timeOutCounter=0;
			// count down ?
			if (timeOutCounter==0)      
			if (bonusTimeout<0.05f)
			{ 
				gameVarTimeout=gameVarTimeout-1;
			}
			
			// down .. 0
			if (gameVarTimeout<=0)
			{
				gameVarTimeout=0;
			}
			

			// ----------------------------
			// representation
			// ----------------------------
			
			// speed of the representation ?
			// [self move];
			keyCounter++;
			if (keyCounter>2)
			  keyCounter=0;
			// keyCounter		// speedup ?
			if ((keyCounter==0)||(bonusSpeedup>0.05f))
				[self move];
				
			
			
			// shield activated ?
			// count down ...
			if (shield>0.0f)
			 shield=shield-0.01f;
			else
			 shield=0.0f;
			
			
			
			
			// reset runners ?
			if ([representation secretLine])
			{
			  [self resetRunners];
			}
			
			// ------------------------
			// big Boss
			// ------------------------
			[enemyBoss setStatus:3];
			
			// bounce ?
			if ([enemyBoss inLiberatedLand:playField])
			{
						// all the same ?
						[self playSoundEffect:@"enemyBoing"];
			}
			
			
			// shoot (bigboss)
			// stand still and shoot ...
			if (bonusTimeout<0.05f)
			if ([enemyBoss doShoot])
			if (enemyBossShoot)
			{
				NSLog(@"l1neumView.doGameCircle.shoot");
			
				// get ...
				// search for a status 
				// and flying 
				int dz=0;
				for (dz=0;dz<[objects count];++dz)
				{
					tpObject * to=[objects objectAtIndex:dz];
						
				
					// to ...
					if ([to flyingFlag])
					if ([to status]==0)
					{
						// NSLog(@"l1neumView.doGameCircle.shoot.addFlyingEnemy");
						// make flying ..
						// status ..
						
						// aim...
						float enemyBX=([enemyBoss getPosition]).x+([enemyBoss size]).x/2;
						float enemyBY=([enemyBoss getPosition]).y+([enemyBoss size]).y/2;
						
						float representantX=([representation getPosition]).x;
						float representantY=([representation getPosition]).y;
					
						// position
						[to setStatus:3];
						[to setPosition:NSMakePoint(enemyBX,enemyBY)];
						
						
						// aim now !
						float distanceX=enemyBX-representantX;
						float distanceY=enemyBY-representantY;
						
						float distance=sqrt(distanceX*distanceX+distanceY*distanceY);
						
						// speed
						float speed=speedFlyingEnemy; 
						
						float aimX=(distanceX/distance)*speed;
						float aimY=(distanceY/distance)*speed;
						
						[to setDirection:NSMakePoint(-aimX,-aimY)];
						
						// play sound
						[self playSoundEffect:@"bigBossShoot"];
						
						break;
					}
				}
				
				// -----------
				// resize?
				// -----------
				int resizeInt=[enemyBoss doResize:playField];
				
				// resize it ..
				if (resizeInt<40)
				 [enemyBoss resizeIt:-10];
				else
				  [enemyBoss resizeIt:10];
				

				
				
			}
			
			
			
			
			// caught ?
			if (![representation secretLine])
			if ([enemyRunner1 status]==3)
			if ((int) ([enemyRunner1 getPosition]).x==(int) ([representation getPosition]).x)
				if ((int) ([enemyRunner1 getPosition]).y==(int) ([representation getPosition]).y)
				{
				
					// NSLog(@"l1neumView.doGameCircle-caught(enemyRunner1)");		
					// deactivate
					[enemyRunner1 setStatus:0];
					[enemyRunner1 resetRunner];
					
					
					// dead
					[self doDie];
				}
				
			// enemy runner 2
			if (![representation secretLine])
			if ([enemyRunner2 status]==3)
			if ((int) ([enemyRunner2 getPosition]).x==(int) ([representation getPosition]).x)
				if ((int) ([enemyRunner2 getPosition]).y==(int) ([representation getPosition]).y)
				{
					
					// deactivate
					[enemyRunner2 setStatus:0];
					
					// dead
					[self doDie];
				}
			
			// counter
			int dz=0;
			
			// -----------------
			// check fireline
			// -----------------
			// runner available ?
			if (([enemyRunner1 status]==0) || ([enemyRunner2 status]==0))
			for (dz=0;dz<[objects count];++dz)
			{
			   tpObject * to=[objects objectAtIndex:dz];

				// NSLog(@"l1neumView.checkFireline %d typeId=%d",dz,[to typeId]);
				 
			   // enemy - search for ...
			   if (([to typeId]==2) || ([to typeId]==4))
			   // activ ?
			   if ([to status]==3)
			   {
			      // ok check
				  tboEnemy * en=[objects objectAtIndex:dz];
				  
				  // NSLog(@"l1neumView.checkFireline:enemy %d",dz);
				  
				  // touched ?
				  if ([en touchFire])
				  {
				    // NSLog(@"l1neumView.checkFireline-found");
					// ok is in there ...
					// first runner
					if ([enemyRunner1 status]==0)
					{
						[enemyRunner1 setStatus:3];
						[enemyRunner1 setPosition: NSMakePoint((int) [en getFireX],(int) [en getFireY])];
					}
					// second runner
					if ([enemyRunner2 status]==0)
					{
						[enemyRunner2 setStatus:3];
						[enemyRunner2 setPosition: NSMakePoint((int) [en getFireX],(int) [en getFireY])];
					}
				  }
			   }
			
			
			}
			
			// -------------------------------- 
			// check killed ?
			// -------------------------------- 
			for (dz=0;dz<[objects count];++dz) 
			{
				tboEnemy * to=[objects objectAtIndex:dz];
					
				// if ([to status]==0)
				if ([to typeId]==4)
				{
					if ([to checkKilled])
					if (![to flyingFlag])
					{
						// sound ?
						// play sound
						[self playSoundEffect:@"enemyDie"];
				
						// add scores ..
						gameVarScore=gameVarScore+gameVarScoreKilledEnemy;
					}
				}
			}
				
			// -------------------------------- 
			// flying things - collision ? 
			// -------------------------------- 
			// aim...
		
			// old version
			/*
			float representantX=([representation getPosition]).x-([representation size]).x/2;
			float representantY=([representation getPosition]).y-([representation size]).y/2;
			float representantXStop=([representation getPosition]).x+([representation size]).x/2;
			float representantYStop=([representation getPosition]).y+([representation size]).y/2;
		
			for (dz=0;dz<[objects count];++dz)
			{
				tpObject * to=[objects objectAtIndex:dz];
			
				// to ...
				if ([to flyingFlag])
				if ([to status]==3)
				{
					float toX=([to getPosition]).x;
					float toY=([to getPosition]).y;
					float toXStop=([to getPosition]).x+([to size]).x;
					float toYStop=([to getPosition]).y+([to size]).y;
		
					if (
							  (toX<representantXStop)
							&&(toX>representantX)
							&&(toY<representantYStop)
							&&(toY>representantY)
						)
					{
						// die :-(
						[self doDie];
					}
					
				}
			}
			*/
			
			// collision on middle point
			float representantX=([representation getPosition]).x-([representation size]).x/2;
			float representantY=([representation getPosition]).y-([representation size]).y/2;

			for (dz=0;dz<[objects count];++dz)
			{
				tpObject * to=[objects objectAtIndex:dz];
			
				// to ...
				if ([to flyingFlag])
				if ([to status]==3)
				{
					float toX=([to getPosition]).x;
					float toY=([to getPosition]).y;
					float toXStop=([to getPosition]).x+([to size]).x;
					float toYStop=([to getPosition]).y+([to size]).y;
		
					if (
							  (representantX>toX)
							&&(representantX<toXStop)
							&&(representantY>toY)
							&&(representantY<toYStop)
						)
					{
						// die :-(
						[self doDie];
					}
					
				}
			}
			
			// ----------------------------
			// check for boing 
			// ----------------------------
			// bounce sound
			int z=0;
			for (z=0;z<[objects count];++z)
			{
				tpObject * to=[objects objectAtIndex:z];
				if ([to status]==3)
				if ([to typeId]==4)
				{
					tboEnemy * en=[objects objectAtIndex:z]; 
					if ([en bounceFlag])
					{
						[self playSoundEffect:@"enemyBoing"];
					}
				}
			}
			
			// ----------------------------
			// bonus 
			// ----------------------------
			for (z=0;z<[objects count];++z)
			{
				tpObject * to=[objects objectAtIndex:z];
				
				
				
				// status - activ
				if ([to typeId]==3)
				{
					if ([to status]==3)
					if ([to inLiberatedLand:playField])
					{
						// bonus sound
						// all the same ?
						[self playSoundEffect:@"bonusFree"];
						
						// bonus .. display
						
						// now display
						// what's in there
						[to setStatus:2];
						
						// use the timer
						// default
						[to setTimer:70.0f];
						
						// ------------------
						// special boni
						// ------------------
						// speedup
						if ([to typeSub]==3)
						   [to setTimer:75.0f];
						
						// timeout
						if ([to typeSub]==4)
						   [to setTimer:50.0f];

						// shield
						if ([to typeSub]==6)
						   [to setTimer:40.0f];
						 
						
						
						// ---------------------
						// "once" boni (1x)
						// ---------------------

						
						// all the various bonus-types
						
					   // points
						if ([to typeSub]==1) gameVarScore=gameVarScore+500;
						// more points
						if ([to typeSub]==2) gameVarScore=gameVarScore+1000;
						// speed up
						if ([to typeSub]==3)
						{
							// NSLog(@"l1neumView.doGameCircle.onceBoni.speedUp");
							bonusSpeedup=0.0f;
		
						}
						// timeout
						if ([to typeSub]==4) 
						{
							// NSLog(@"l1neumView.doGameCircle.onceBoni.bonusTimeout");
							bonusTimeout=0.0f;
						}
						// more time ..
						if ([to typeSub]==5) 
						{
							// NSLog(@"l1neumView.doGameCircle.onceBoni.gameVarTimeout");
							gameVarTimeout=gameVarTimeout+300;
						}
						// shield
						if ([to typeSub]==6) 
						{
							// NSLog(@"l1neumView.doGameCircle.onceBoni.shield");
							bonusShield=0.0f;
						}
						// nextlevel
						if ([to typeSub]==7) 
						{
							// NSLog(@"l1neumView.doGameCircle.onceBoni.nextLevel");
							// nextLevel
							[self nextLevel];
						}
						// ++ life
						if ([to typeSub]==7) 
						{
							// NSLog(@"l1neumView.doGameCircle.onceBoni.++life");
							++gameVarLifes;
						}

						
						
					}
					
					// down
						[to setTimer:[to timer]-0.1f];
						if ([to timer]<0.0f) [to setTimer:0.0f];	
					
					// count down now
					if ([to status]==2)
					{
						// bonus .. display
						
						
						
						// use the timer
						if ([to timer]>0.0f)
						{
							
							
							// ---------------------
							// dynamic boni
							// ---------------------
							
							// speed up
							if ([to typeSub]==3)
							{
								bonusSpeedup=[to timer];
			
							}
							// timeout
							if ([to typeSub]==4) 
							{
								bonusTimeout=[to timer];
							}
							// shield
							if ([to typeSub]==6) 
							{
								bonusShield=[to timer];
							}
						
						}
						
						// end ...
						if ([to timer]<0.0f)
						{
							[to setStatus:0];	
						}
						
						
						
					}
					
				}	
			}
			
		}

		
		// do emotics ..
		if 
		  (
			((systemModeSub==2) ) // && (systemEmotions)
		    ||
		    (systemModeSub==5)
		   || (systemModeSub==6)
		  )
		{
			// doEmotions 
			[self doEmotions];
		}
		
		
	}
	
	
}

	// doEmotions
	- (void) doEmotions
	{
		// emotionleveldirection
		// if (emotionLevelDirection==0)
		// else
		 
		// emotion
		
		// VX
		if (emotionLevelAXDirection==0)
		{
		  if (emotionLevelAX<emotionLevelMaxAX)
			emotionLevelAX=emotionLevelAX+emotionLevelAXSpeed;
		  else
		   emotionLevelAXDirection=1; 
		}
		else
		{
		  if (emotionLevelAX>-emotionLevelMaxAX)
			emotionLevelAX=emotionLevelAX-emotionLevelAXSpeed;
		  else
		    emotionLevelAXDirection=0;  
		}
		
		// VY
		if (emotionLevelAYDirection==0)
		{
		  if (emotionLevelAY<emotionLevelMaxAY)
			emotionLevelAY=emotionLevelAY+emotionLevelAYSpeed;
		  else
		   emotionLevelAYDirection=1; 
		}
		else
		{
		  if (emotionLevelAY>-emotionLevelMaxAY)
			emotionLevelAY=emotionLevelAY-emotionLevelAYSpeed;
		  else
		    emotionLevelAYDirection=0;  
		}
		
		// new speed
		// emotionSpeedX=emotionLevelA;
		// emotionSpeedY=emotionSpeedY+emotionLevelA;
		
		// rotation 
		xrot=xrot+emotionLevelAX;
		yrot=yrot+emotionLevelAY;
		// zrot=zrot+emotionLevelAY;
		
		/*
		NSLog(@"l1neumView.doEmotions(%d/%f)",emotionLevelAXDirection,emotionLevelAX);
		NSLog(@"l1neumView.doEmotions(%d/%f)",emotionLevelAYDirection,emotionLevelAY);
		*/
		
		
		/*
		// level goes down
		emotionLevel=emotionLevel-emotionLevelDown;
		if (emotionLevel<emotionLevelMin)
		  emotionLevelMin=emotionLevelMin;
		
	
		// new speed
		emotionSpeedX=emotionSpeedX+emotionXA;
		emotionSpeedY=emotionSpeedY+emotionYA;
		
		// rotation 
		xrot=xrot+emotionSpeedX;
		yrot=yrot+emotionSpeedY;
		
		*/
		
	}

	
	// doThreadObjects
	- (void) doThreadObjects
	{
				
		// project BonusObjects ...
		[self projectBonusObjectsToPlayField];
								
		int dz=0;
		for (dz=0;dz<[objects count];++dz)
		{
		   tpObject * to=[objects objectAtIndex:dz];

			// doThread
			[to doThread:playField];
		}
	
		// remove project BonusObjects ...
		[self removeBonusObjectsToPlayField];
		
	}
	
	// doDie
	// your representation dies
	- (void) doDie
	{
		// shield
		if ((shield==0.0f) && (bonusShield<0.05f)) // if shield is not activated
		{
				// play sound
				[self playSoundEffect:@"representationDie"];
		
				// no more lifes
				--gameVarLifes;
				
				// end of the game
				if (gameVarLifes==0)
				{
					// game over ...
					//  
					// play sound
					[self playSoundEffect:@"gameOver"];

					
					// sound !
					systemModeSub=5;
				}
				
				// add animation etc
				// -> explosion
				
				// back to  oldPositionX/oldPositionY
				[representation setPosition:NSMakePoint(oldPositionX,oldPositionY)];
				
				// clean up the fireline
				// clean up
				// back to security line
				int qz=0;
				int qzz=0;
				for (qz=0;qz<playFieldCountX;++qz)
				{
					 for (qzz=0;qzz<playFieldCountY;++qzz)
					 {
						// 2 - ? (other ++)
						if (playField[qz][qzz]==3)
						{
							// clean
							playField[qz][qzz]=0;
						}
					}
				}
				
				// set status
				[representation setSecretLine:true];
				statusFire=false;
				
				// shield ?
				shield=10.0f;
				
				
				// resetRunners
				[self resetRunners];
		
		}
		
	}
	
	// ----------------------
	//  highscore ?
	// ----------------------
	- (BOOL) highScore
	{
	    NSLog(@"l1neumView.highScore");
		
		BOOL isOne=false;
	
		// insertmode ?
		if (!highscoreInsertMode)
		{
				// gameVarScore
				// gameVarLevel
				// highscoreInsertMode=false;
				
				// check the whole scores now
				positionInHighscores=-1;
				
				int i=0;
				if (gameVarScore>hiScoresPoints[0])
				for (i=0;i<10;++i)
				{
					if (gameVarScore<hiScoresPoints[i])
					{
						positionInHighscores=i-1;
						break;
					}
					
					// ..
					// NSMutableString * namemt = [hiScoresName objectAtIndex:i];
				}
				
				// yeah top ot the top
				if (gameVarScore>hiScoresPoints[9])
				{
					positionInHighscores=9;

				}

				// new highscore
				if (positionInHighscores>-1)
				{
					// NSLog(@"l1neumView.highScore.newScore !!! position: %d",positionInHighscores);
					
					// found one
					isOne=true;
					
					// set highscoreInserMode=true
					highscoreInsertMode=true;
					
					
					// go to higscore and insert there
					systemMode=1;	
					systemModeSub=3;
					systemModeSubMode=1;
					 
					
					
					// NSLog(@"l1neumView.highScore.newScore !!! position: %d mode %d/%d insertmode:%d",positionInHighscores,systemMode,systemModeSub,highscoreInsertMode);
					
					// pull down others !
					if (positionInHighscores>0)
					{
						int u=(positionInHighscores+1);
						
						for (i=1;i<u;++i)
						{
							hiScoresPoints[i-1]=hiScoresPoints[i];
							NSMutableString * namemt = [hiScoresName objectAtIndex:i-1];
							NSString * namemtmove = [hiScoresName objectAtIndex:i];
							[namemt setString:namemtmove];
						}
				
					}
					
					// hiScoresPoints
					hiScoresPoints[positionInHighscores]=gameVarScore;
					NSString * namemt = [hiScoresName objectAtIndex:positionInHighscores];
					[namemt setString:@""];

					
					
				}
		}
	
		return isOne;
	}

// ------------------------------
// keystrokes etc
// ------------------------------

- (void) keyDownDirect: (unichar) unicodeKey
{

	BOOL finished=false;
	
	
	if (highscoreInsertMode)
	if (positionInHighscores!=-1)
	if (positionInHighscores>-1)
	if (positionInHighscores<10)
	{

		//	NSLog(@"l1neumView.keyDown: char: %c ",unicodeKey);
		//	NSLog(@"l1neumView.keyDown: key: %d ",unicodeKey);
	
		// NSLog(@"l1neumView.highScore.newScore !!! position: %d mode %d/%d insertmode:%d",positionInHighscores,systemMode,systemModeSub,highscoreInsertMode);


			BOOL parsed=false;
			
				
			// max pos
			int max=7;
			
			
			// back
			if (unicodeKey==127)
			{
				// go back
				NSMutableString * namemt = [hiScoresName objectAtIndex:positionInHighscores];
				if ([namemt length]>0)
				 [namemt setString: [namemt substringToIndex:[namemt length]-1]];
			   
				parsed=true;
			}
			
			// return
			// second one !
			if (unicodeKey==13)
			{
				// highscoreInsertMode=false;
				
			    finished=true;
				
				
				parsed=true;
			}
		
			// new chars
			if (!parsed)
			{
			   NSMutableString * namemt = [hiScoresName objectAtIndex:positionInHighscores];
			   [namemt appendFormat:@"%c",unicodeKey];	
			   
			   // to much ?
			   if ([namemt length]>(max-1))
			   {
				  
				   finished=true;
				}
			}
			
			// play sound
			[self playSoundEffect:@"menuNextPoint"];
			
			// save it
			if (finished)
			{
			   
				// add level behind
				NSMutableString * namemt = [hiScoresName objectAtIndex:positionInHighscores];
			    [namemt appendFormat:@" %d",(gameVarLevel+1)];	
				
				// + date ?
				
				 // save ..
				[self savePrefs];
				
				 // back
				 positionInHighscores=-1;
				 NSLog(@"l1neumView.keyDownDirect.finish");
				 highscoreInsertMode=false;
				 systemModeSubMode=1;
				 
			}
	}
	
}


- (void) setKeyStatus: (int)moveid value:(BOOL)value
{
	// NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];


//	NSLog(@"l1neum.setKeyStatus(systemMode=%d / systemModeSub=%d / systemModeSubMode=%d)",systemMode,systemModeSub,systemModeSubMode);

	BOOL consumed=false;
	if (highscoreInsertMode)
	{
		// NSLog(@"l1neum.setKeyStatus(systemMode=%d / systemModeSub=%d / systemModeSubMode=%d) --- %d",systemMode,systemModeSub,systemModeSubMode,highscoreInsertMode);

	}
	
	// don't use this in insert mode
	if (!highscoreInsertMode)
	{


			// -------------------
			// left
			// -------------------
			if (moveid==1) 
			{
			
				// in game
				if (systemMode==2)
				{
					// in game
					if (systemModeSub==1)
					  statusMove1=value;
			
					  // in game paused
					  // pause or exit
					  if (value)
					  {
						 
						  if (systemModeSubMode==1)
						  {
							systemModeSubMode=0;
						  }
						  else
						  {
							systemModeSubMode=1;
						  }
					  }
				}
			}
			// -------------------
			// right
			// -------------------
			if (moveid==2) 
			{
				// in game
				if (systemMode==2)
				{
					// in game
					if (systemModeSub==1)
					  statusMove2=value;
			
					  // in game paused
					  // pause or exit
					  if (value)
					  {
						 
						  
						  
						  if (systemModeSubMode==1)
						  {
							systemModeSubMode=0;
						  }
						  else
						  {
							systemModeSubMode=1;
						  }
					  }
				}
			}
			// -------------------
			// up
			// -------------------
			if (moveid==3) 
			{

				
				// menu Mode
				if (systemMode==1)
				if (value)
				{
				
				  // play effect
				  if (soundEffects)
				  {
					[self playSoundEffect:@"menuNextPoint"];
				  }
				
				  // main
				  if (systemModeSubMode==-1)
				  {
					--systemModeSub;
					if (systemModeSub<0)
					 systemModeSub=5;
				  }
				  
				  // sub
				  if (systemModeSubMode==1)
				  {
					
						// settings
						--systemModeSubSettings;
						if (systemModeSubSettings<0)
						  systemModeSubSettings=7;
				  
				  }
				  
					// NSLog(@"l1neumView.setKeyStatus:value)=%d",systemModeSub);

				}
				
				
				// game Mode
				if (systemMode==2)
				{
				  // in game
				  if (systemModeSub==1)
				  {
					statusMove3=value;
			
				  
				  }
				 
				 
				}
			}
			
			// -------------------
			// down
			// -------------------
			if (moveid==4) 
			{
				// menu Mode
				if (systemMode==1)
				if (value)
				{
				  // play effect
				  // play effect
				  if (soundEffects)
				  {
					[self playSoundEffect:@"menuNextPoint"];
				  }
					
				  // main
				  if (systemModeSubMode==-1)
				  {
						++systemModeSub;
						if (systemModeSub>5)
						 systemModeSub=0;
				  }
				  
				  // submain
				  if (systemModeSubMode==1)
				  {
						// settings
						++systemModeSubSettings;
						if (systemModeSubSettings>7)
						  systemModeSubSettings=0;
					
				  }

					// NSLog(@"l1neumView.setKeyStatus:value)=%d",systemModeSub);

				}
			
				// game Mode
				if (systemMode==2)
				{
					statusMove4=value;
					
				}
			}
			
			// -------------------
			// fire
			// -------------------
			if (moveid==5) 
			{
				

				// -------------------
				// intro mode
				// -------------------
				if (systemMode==0)
				if (value)
				{   
					// direct to Menu
					systemMode=1;	
					systemModeSub=0;
					
					consumed=true;
					
					// play effect
					  if (soundEffects)
					  {
						[self playSoundEffect:@"menuClicked"];
					  }
				}
				
				// -------------------
				// menu mode
				// -------------------

				if (systemMode==1)
				if (!consumed)
				if (value)
				{ 
					
					// play effect
					if (soundEffects)
					{
						[self playSoundEffect:@"menuClicked"];
					}
				  
					// -------------------
					// normal main
					// -------------------
					if (systemModeSubMode==-1)
					{
					
								// play
								if (systemModeSub==0)
								{
									systemMode=2;
									systemModeSub=1;
									
									// start music
									if (systemMusic)
									{
									 GoToBeginningOfMovie ([musicInGame QTMovie]);
									 StartMovie ([musicInGame QTMovie]);
									}
									
									// -start level
									[self firstLevel];
								}
								
								// settings
								if (systemModeSub==1)
								{
									// activate submode
									systemModeSubMode=1;
								}
								
								// rulez
								if (systemModeSub==2)
								{

									// activate submode
									systemModeSubMode=1;			
								}
								
								// highscore
								if (systemModeSub==3)
								{

										// activate submode
										systemModeSubMode=1;
									
								}
								
								// website
								if (systemModeSub==4)
								{
									// [[[NSAppleScript alloc] initWithSource:@"do shell script \"open http://127.0.0.1\""] executeAndReturnError:nil];
									[[NSWorkspace sharedWorkspace] openURL:[NSURL URLWithString:@"http://www.la1n.ch/l1neum/?request=game&version=1.0"]];
							
								}
								
								// quit
								if (systemModeSub==5)
								{
									 ExitToShell();
								}
					
					}
					// submain
					else
					{
						// NSLog(@"l1neumView.setKeyStatus.submenu");
							
							
						  // play effect
						  if (soundEffects)
						  {
							[self playSoundEffect:@"menuClicked"];
						  }
										
								// settings
								if (systemModeSub==1)
								{
								
									// video
									// 0-1
									if (systemModeSubSettings==0)
									{
										systemWindowModeBig=false;
										
										// small window
										
										NSRect frame = [[self window] frame];
										frame.size.width=800;
										frame.size.height=570;
										
										[[self window] setFrame:frame display:YES animate:false];
										// zoom it ..
										[[self window] center]; 
										// [[self window] reshape];
										
			
									}
									
									// big window
									if (systemModeSubSettings==1)
									{
										systemWindowModeBig=true;
										
										NSRect frame = [[self window] frame];

										NSRect screenRect = [[NSScreen mainScreen] frame];

										frame.origin.x=screenRect.origin.x+30;
										frame.origin.y=screenRect.origin.y+30;
										frame.size.width=screenRect.size.width-60;
										frame.size.height=screenRect.size.height-60;

										[[self window] setFrame:frame display:YES animate:YES];
										// [[self window] reshape];
										// zoom it ..
										[[self window] center]; 
										
									   
									}
									
									// video
									// 2-4
									if (systemModeSubSettings==2)
										graphics=10;
									if (systemModeSubSettings==3)
										graphics=1;
									if (systemModeSubSettings==4)
										graphics=0;
									
									// audio
									if (systemModeSubSettings==5)
									{	
										if (systemMusic)
										 systemMusic=false;
										 else 
										 systemMusic=true;
									}
									
									// emotics ? 
									if (systemModeSubSettings==6)
									{	
										if (systemEmotions)
										 systemEmotions=false;
										 else 
										 systemEmotions=true;
									
										  NSLog(@"l1neumView.setKeyStatus:systemEmotions=%d",systemEmotions);
									}
									
									// back
									if (systemModeSubSettings==7)
										systemModeSubMode=-1;
									
								}
								
								// rulez
								if (systemModeSub==2)
								{

									// activate submode
									systemModeSubMode=-1;			
								}
								
								// highscore
								if (systemModeSub==3)
								{

									// don't go there if in insert mode
									if (!highscoreInsertMode)
									{
										// activate submode
										systemModeSubMode=-1;			
									}
								}
								
					
					}
					
					consumed=true;
					
				}
				
				// -------------------
				// in game
				// -------------------
				if (systemMode==2)
				if (!consumed)
				{
					// NSLog(@"l1neumView.m=%f,%f,%f",xrot,yrot,zrot);
					
					// in game fire
					if (systemMode==2)
					{ 
					   // in game
					   if ((systemModeSub==1) || (systemModeSub==0))
						statusFire=value;
					
					   // continue - exit ?
					   if (systemModeSub==2)
					   if (value)
					   {
						  // play effect
						  if (soundEffects)
						  {
							[self playSoundEffect:@"menuNextPoint"];
						  }
						  
					   
							// continue
							if (systemModeSubMode==0)
							{
							 
							  systemModeSub=1;
							
								// resetKeyStati
								[self resetKeys];
							}  
							// exit to menu
							if (systemModeSubMode==1)
							{
							   systemMode=1;
							   systemModeSub=0;
							   systemModeSubMode=-1;
							
								GoToBeginningOfMovie ([musicTitleTheme QTMovie]);
								StartMovie ([musicTitleTheme QTMovie]);

								// resetKeyStati
								[self resetKeys];
							}
					
					   }
					
					}
					
					// nextLevel
					if (systemModeSub==4)
					if (value)
					if (menuTimer==0.0f)
					{
						// next Level ..
						[self nextLevel];
						
						// play effect
						  if (soundEffects)
						  {
							[self playSoundEffect:@"menuNextPoint"];
						  }
						  
					
					}
					
					// game over
					if (systemModeSub==5)
					if (value)
					if (menuTimer==0.0f)
					{
					
						// check new highscore ?
						if (![self highScore])
						{
							systemMode=1;
							systemModeSub=0;
							systemModeSubMode=-1;
						
							// play effect
							  if (soundEffects)
							  {
								[self playSoundEffect:@"menuNextPoint"];
							  }
						}	  
					}
					
					// game end
					if (systemModeSub==6)
					if (value)
					if (menuTimer==0.0f)
					{
						// check new highscore ?
						if (![self highScore])
						{
							 // play effect
							  if (soundEffects)
							  {
								[self playSoundEffect:@"menuNextPoint"];
							  }
							  
							systemMode=1;
							systemModeSub=0;
							systemModeSubMode=-1;
						}
					}
					
					
				}
			}
			
			// pause 'p'
			// esc
			// down
			if (moveid==6) 
			if (value)
			{
				
				  // play effect
				  if (soundEffects)
				  {
					[self playSoundEffect:@"menuClicked"];
				  }
						  
				// game mode
				if (systemMode==2)
				{   BOOL consumed=false;
				
					// init pause
					if ((systemModeSub==1)||(systemModeSub==0))
					{
						// pause !
						systemModeSub=2;
						systemModeSubMode=0;
						consumed=true;

						// resetKeyStati
						[self resetKeys];
					}
				
					// game mode pause
					if (systemModeSub==2)
					if (!consumed)
					{
					
						// NSLog(@"l1neumView.setKeyStatus: gameModePause x 2 esc");
						// pause !
						systemModeSubMode=0;
						
						systemModeSub=1;
							
						// resetKeyStati
						[self resetKeys];
						
					}
					
					
					
					
					
				}
			}
			
	}
	
	
	// [pool release];
}
			// resetKeys
			- (void) resetKeys
			{
				// ----------------
				 // keys
				 // ----------------
				 statusMove1=false;
				 statusMove2=false;
				 statusMove3=false;
				 statusMove4=false;
				 
				 statusFire=false;
				 
			}

		// firstLevel
		// start game
		- (void) firstLevel
		{
			[self resetGame];
			[self resetLevel];
			[self nextLevel];
			
		}

		// nextLevel
		- (void) nextLevel
		{
			
		
			NSLog(@"l1neumView.nextLevel(%d)",(gameVarLevel+1));
			// reset
			
			// next level
			++gameVarLevel;

			
			// last level
			if (gameVarLevel==gameVarEndLevel)
			{
				// end of all
				systemModeSub=6;
				menuTimer=30.0f;
			}
			
			// not the last level ?
			if (gameVarLevel!=gameVarEndLevel)
			{
			
			
					// reset
					[self resetLevel];
					
					// add score
					gameVarScore=gameVarScore+gameVarLevel*1000;
					
					// back to game mode ..
					systemModeSub=1;
					
					// shield at the beginning
					shield=1.0f;
					
					// --------------
					// view ..
					// --------------
					originxrot=-24.0f;
				    originyrot=3.5f; // 0.0f
				    originzrot=0.0f;
					
					
					// -------------
					// levels 
					// -------------
					// not transparent - transparent
					textureGameActualLevelEnableTransparent=false;

					// not transparent - transparent
					textureGameActualLevelTransparent=1.0f;

					// -----------------
					// enemy behavior
					// ------------------
					// levelX
					// count
					int enemiesSmall=3;
					

					// -------------
					// big boss
					// -------------
					// shoot
					enemyBossShoot=true;
					
					// animation
					animationReverse=false;
					
					// size
					enemyBigWidth=60;
					enemyBigHeight=60;

					enemyWidth=30;
					enemyHeight=30;

					enemyFlyWidth=20;
					enemyFlyHeight=20;
					
					// his friends / slaves
					// enemyFlyingBehavior
					// speed
					speedFlyingEnemy=0.2f;
					
					
					
					// --------------
					// bonuscodes
					// --------------
						// ---------------
						// typeIdSub
						// ---------------
						// 0 - nop 
						// 1 - points
						// 2 - morepoints
						// 3 - speedup
						// 4 - timeout
						// 5 - moretime
						// 6 - shield
						// 7 - nextlevel : don't use this !!!! (it's  not very interesting for the gameplay)
						// 8 - life
						// 9 - shoot

					// level 1
					if (gameVarLevel==0)
					{
						// time to go
						gameVarTimeout=1000;
						
						[self addBonus:5 y:1 type:3];
						
						
						// bigboss
						enemyBossShoot=false;
						
						// animation
						animationReverse=true;
						
						// enemy 
						speedFlyingEnemy=0.3f;
						
						enemiesSmall=2;
						
					}
					
					// level 2
					if (gameVarLevel==1)
					{
					
						originxrot=-24.0f;
						originyrot=3.5f; // 0.0f
						originzrot=0.0f;
						
						// time to go
						gameVarTimeout=800;
						
						[self addBonus:6 y:6 type:1];
						[self addBonus:6 y:7 type:3];
						[self addBonus:7 y:7 type:2];
						[self addBonus:7 y:8 type:1];
						[self addBonus:12 y:1 type:2];
						
						// transparent
						textureGameActualLevelEnableTransparent=true;
						textureGameActualLevelTransparent=0.8f;
					
						// animation
						animationReverse=true;
						
						// 
						enemiesSmall=3;
						
						// big boss
						enemyBigWidth=100;
						enemyBigHeight=100;
					}
					
					// level 3
					if (gameVarLevel==2)
					{
					
						
						// time to go
						gameVarTimeout=500;
						
						[self addBonus:5 y:2 type:1];
						[self addBonus:7 y:3 type:1];
						
						// transparent
						textureGameActualLevelEnableTransparent=true;
						textureGameActualLevelTransparent=0.8f;
					
						// animation
						animationReverse=true;
						
						// 
						enemiesSmall=3;
						
						// faster
						speedFlyingEnemy=0.3f;
						
						// big boss
						enemyBigWidth=150;
						enemyBigHeight=150;
						
						// enemy 
						enemyWidth=10;
						enemyHeight=10;

						// fly
						enemyFlyWidth=10;
						enemyFlyHeight=10;
						
					}
					
					
					// level 4
					if (gameVarLevel==3)
					{
						// time to go
						gameVarTimeout=500;
						
						// add 2 boni 
						[self addBonus:8 y:12 type:2];
						[self addBonus:8 y:11 type:3];
						[self addBonus:8 y:10 type:2];
						[self addBonus:8 y:9 type:1];
						[self addBonus:8 y:6 type:8];

						// transparent
						textureGameActualLevelEnableTransparent=false;
						textureGameActualLevelTransparent=1.0f;

						enemyShootType=2;
						enemiesSmall=4;
						
						// faster
						speedFlyingEnemy=0.4f;

					}
				
					// level 5
					if (gameVarLevel==4)
					{
						// time to go
						gameVarTimeout=400;
						
						// add 2 boni 
						[self addBonus:1 y:4 type:2];
						[self addBonus:2 y:4 type:2];
						[self addBonus:3 y:4 type:2];
						[self addBonus:4 y:4 type:4];
						
						
						// transparent
						textureGameActualLevelEnableTransparent=false;
						textureGameActualLevelTransparent=1.0f;

						enemyShootType=1;
						enemiesSmall=5;

						// faster
						speedFlyingEnemy=0.5f;

					}
				
					// level 6
					if (gameVarLevel==5)
					{
						// time to go
						gameVarTimeout=500;
						
						// add 2 boni 
						[self addBonus:2 y:6 type:1];
						[self addBonus:3 y:7 type:6];
						[self addBonus:4 y:6 type:1];
						[self addBonus:5 y:7 type:5];


						// transparent
						textureGameActualLevelEnableTransparent=false;
						textureGameActualLevelTransparent=1.0f;

						enemyShootType=1;
						enemiesSmall=5;
						
						// faster
						speedFlyingEnemy=0.5f;
					}
					
					// level 7
					if (gameVarLevel==7)
					{
						// time to go
						gameVarTimeout=400;
						
						// add 2 boni 
						[self addBonus:6 y:6 type:1];
						[self addBonus:7 y:7 type:1];
						[self addBonus:8 y:8 type:1];


						// transparent
						textureGameActualLevelEnableTransparent=false;
						textureGameActualLevelTransparent=1.0f;

						enemyShootType=1;
						enemiesSmall=5;
						
						enemyBigWidth=60;
						enemyBigHeight=60;

						enemyWidth=60;
						enemyHeight=60;

						enemyFlyWidth=60;
						enemyFlyHeight=60;
						
						
						// faster
						speedFlyingEnemy=0.6f;
					}

							
					// activate all used enemies
					int dz=0;
					for (dz=0;dz<[objects count];++dz)
					{
						tpObject * to=[objects objectAtIndex:dz];
					
						// to ...
						if ([to typeId]==4)
						if ([to status]==0)
						if (![to flyingFlag])
						{
							// NSLog(@"l1neumView.resetLevel.addEnemyForLevel [%d]",dz);
							[to setStatus:3];
							[to setPosition:NSMakePoint(playFieldCountX/2,playFieldCountY/2)];
							[to setPosition: NSMakePoint(SSRandomIntBetween(13,playFieldCountX/2),SSRandomIntBetween(13,playFieldCountY/2))];

							
							--enemiesSmall;
							if (enemiesSmall==0)
							 break;
						}
					}
					
					
					// ---------------------------
					// resize them all
					// ---------------------------
					for (dz=0;dz<[objects count];++dz)
					{
						tpObject * to=[objects objectAtIndex:dz];
					
						// to ...
						if ([to typeId]==4)
						{
							// no fly ..
							if (![to flyingFlag])
							{
								[to setSize: NSMakePoint(enemyWidth,enemyHeight)];
							}
							// fly
							else
							{
								[to setSize: NSMakePoint(enemyFlyWidth,enemyFlyHeight)];	
							}
						}
					}
					
					// enemyBig
					[enemyBoss setSize: NSMakePoint(enemyBigWidth,enemyBigHeight)];	
					
					
					// -------------
					// levelBase
					// -------------
					int baseId=51;
					int multiplicator=6;

					textureGameActualLevel=baseId+multiplicator*gameVarLevel;
					textureEnemyBigBoss=baseId+multiplicator*gameVarLevel+1;
					textureEnemy=baseId+multiplicator*gameVarLevel+4;
					textureEnemyFly=baseId+multiplicator*gameVarLevel+5;
					
					// next level
					textureGameNextLevel=baseId+multiplicator*(gameVarLevel+1);
					
					
					// special - bug ?
					if (gameVarLevel==0)
					  textureGameActualLevel=50; 
					
					// NSLog(@"l1neumView.nextLevel=%d (textureGameActualLevel=%d)",gameVarLevel,textureGameActualLevel);
					
					// representation
					[representation setPosition: NSMakePoint(playFieldCountX/2,1)];
			}		
		}


						// -------------------
						// addBonus
						// -------------------
						// insert a bonus 
						// x=1 -> fieldx=x*30
						// y=5 -> fieldy=y*30
						- (void) addBonus:(int)x y:(int)y type:(int)typus
						{
							
							if (typus<0) typus=0;
							if (typus>9) typus=9;
							
							if (x<0) x=0;
							if (y<0) y=0;
							if (x>12) x=12;
							if (y>12) y=12;
						
							// search bonus free
							int dz=0;
							for (dz=0;dz<[objects count];++dz)
							{
								tpObject * to=[objects objectAtIndex:dz];
							
								// to ...
								if ([to typeId]==3)
								if ([to status]==0)
								{
									// react
									[to setStatus:3];
									[to setTypeIdSub:typus];
									[to setPosition:NSMakePoint(x*30+5,y*30+5)];
									
									 break;
								}
							}
							
						}


// ----------------------------
// action representation
// ----------------------------


// do move

// move / do it konkrete
- (void) move
{

   // NSLog(@"l1neumView.move(%d)",key);
   
   // 1 - left
   // 2 - top
   // 3 - up
   // 4 - down
   
   int key=0;
   
   if (statusMove1) key=1;
   if (statusMove2) key=2;
   if (statusMove3) key=3;
   if (statusMove4) key=4;
   
   int representationX=([representation getPosition]).x;
   int representationY=([representation getPosition]).y;
   int newrepresentationX=representationX;
   int newrepresentationY=representationY;

   
   // mode: game
   BOOL parsedF=false;
   
		// left
		if (key==1) 
		{
			representationX=representationX-1;
			parsedF=true;
		}

		// right
		if (key==2) 
		{
			representationX=representationX+1;
			parsedF=true;
		}
		
		// up
		if (key==3) 
		{
			representationY=representationY+1;
			parsedF=true;
		}

		// down
		if (key==4) 
		{
			representationY=representationY-1;
			parsedF=true;
		}

		// new ...
		if (parsedF)
		{
		
			// NSLog(@"l1neumView.move.status(availabelOffline=%d,osecretLine=%d)",[representation avaibleOffLine],[representation secretLine]);

			// possible to go there ?
			
			// case: on the line - just driving there
			if (playField[representationX][representationY]==2)
			if ([representation secretLine])
			{
				[representation setPosition: NSMakePoint(representationX,representationY)];
				
				oldPositionX=representationX;
				oldPositionY=representationY;
			}
			
			// case: breaking out
			if (playField[representationX][representationY]==0)
			if ([representation secretLine])
			if (statusFire)
			{
				[representation setAvaibleOffLine:true];
				
				// NSLog(@"breaking out");
				// store old position here ..
				oldPositionX=([representation getPosition]).x;
				oldPositionY=([representation getPosition]).y;
			
				[representation setPosition: NSMakePoint(representationX,representationY)];
				[representation setSecretLine:false];
				
				// set back 
				[representation setAvaibleOffLine:false];
			}

			
			// case: in "enemies" land ..

			// project BonusObjects ...
			[self projectBonusObjectsToPlayField];


			if (playField[representationX][representationY]==0)
			if (![representation secretLine])
			{
				
				BOOL doIt=true;
				
				
				// ------------------------------
				// prevent contact own line
				// ------------------------------
				// left 
				if (key==1) { if (playField[representationX-1][representationY]==3) {doIt=false;}}
				// right 
				if (key==2) { if (playField[representationX+1][representationY]==3) {doIt=false;}}
				// up 
				if (key==3) { if (playField[representationX][representationY+1]==3) {doIt=false;}}
				// down 
				if (key==4) { if (playField[representationX][representationY-1]==3) {doIt=false;}}
				
				// ---
				//    |
				// <--
				if (key==1) { if (playField[representationX-1][representationY-1]==3) {doIt=false;}}
				if (key==1) { if (playField[representationX-1][representationY+1]==3) {doIt=false;}}
				
				// ----
				// |   
				// --->
				if (key==2) { if (playField[representationX+1][representationY-1]==3) {doIt=false;}}
				if (key==2) { if (playField[representationX+1][representationY+1]==3) {doIt=false;}}
					
				
				//   ^
				// |_|
				// up 
				if (key==3) { if (playField[representationX-1][representationY+1]==3) {doIt=false;}}
				if (key==3) { if (playField[representationX+1][representationY+1]==3) {doIt=false;}}
				
				// |--|
				// | \/
				if (key==4) { if (playField[representationX-1][representationY-1]==3) {doIt=false;}}
				if (key==4) { if (playField[representationX+1][representationY-1]==3) {doIt=false;}}
				
				
				// stop ..
				if (!doIt)
				{
					// vesselsound
					// in enemys land ..
					// [self playSoundEffect:@"noWay"];
				}
						
				// special things ...
				if (doIt)
				{
				   playField[representationX][representationY]=3;
				   [representation setPosition: NSMakePoint(representationX,representationY)];
				
					// sound ?
					// vesselsound
					// in enemys land ..
					if (![soundVesselTerrain isPlaying])
					 [soundVesselTerrain play];
					 
				}
				
				
				// generateFireLine
				if (displayFireLineVertical)
				  [self generateWallsFireLineForDisplay];
				
			}
			// remove project BonusObjects ...
			[self removeBonusObjectsToPlayField];

			
			// case: back to the secret line
			if (playField[representationX][representationY]==2)
			if (![representation secretLine])
			{
				// NSLog(@"Status:BackOnSecretLine");
			
				// new flat
				// do it ..
				++flat;
			
				// playField[representationX][representationY]=3;
				[representation setPosition: NSMakePoint(representationX,representationY)];
				[representation setAvaibleOffLine:false];
				[representation setSecretLine:true];
				
				
				// method: slow motion
				// fill from bigboss to periph.
				
				int px=(int) ([enemyBoss getPosition]).x+([enemyBoss size]).x/2;
				int py=(int) ([enemyBoss getPosition]).y+([enemyBoss size]).y/2;
				playField[px][py]=5;
 
				// fire line
				[self generateWallsFireLineForDisplay];

				// NSLog(@"l1neumView.move.generateWallsFireLineDisplay()");
				
				// do it recursivly
				[self fillPlaygroundExtended];
				// [self fillPlayground];

				// NSLog(@"l1neumView.move.fillPlayground.timestamp:%l",time());
				
				// invert ..
				[self invertPlayground];
				
				// turn the 3 into -> 20+
				[self generateNewSecureLine];
				
				 
				// generateWallsForDisplay
				[self generateWallsForDisplay];
				
				
				
				// in the nowhere-case 
				// search the next possible position ..
				if (playField[(int) ([representation getPosition]).x][(int) ([representation getPosition]).y]!=2)
				{
					// take oldPositionX / oldPositionX
					[representation setPosition:NSMakePoint(oldPositionX,oldPositionY)];
				}
				
					// not yet ok ?
					// search first ...
					if (playField[(int) ([representation getPosition]).x][(int) ([representation getPosition]).y]!=2)
					{
					    int dx=playFieldCountX+playFieldCountY;
						int posX=playFieldCountX-1;
						int posY=playFieldCountY-1;
						
						int repX=(int) ([representation getPosition]).x;
						int repY=(int) ([representation getPosition]).y;
						
						// search next .. one
						int z=0;
						int zz=0;
						for (z=0;z<playFieldCountX;++z)
						 for (zz=0;zz<playFieldCountY;++zz)
						 if (playField[z][zz]==2)
						 {
							int tmpdiff= (int) sqrt((z-repX)*(z-repX)+(zz-repY)*(zz-repY));
							
							if (tmpdiff<dx )
							{
								dx=tmpdiff;
								posX=z;
								posY=zz;
							}
						 }
						 
						 // new position
						 [representation setPosition:NSMakePoint(posX,posY)];
						 
					}
					
				// reset runners
				[self resetRunners];
				 
				// old
				float oldPercent=percent;
				
				// % ... 
				percent=(((float) (dotesCount-playFieldCountX-playFieldCountY))/(float) ((playFieldCountX-1)*(playFieldCountY-1)));
				// NSLog(@"percent =%f",percent);
				
				float differencePercent=percent-oldPercent;
				
				// add points
				gameVarScore=gameVarScore+(int) (differencePercent*500.0f*100.0f);
				
				
				// display "visual"
				[self playSoundEffect:@"fireLineEnd"];
				
				// end level
				if (percent>0.80f)
				{
					// not expon. (*todo: better expon)
					gameVarScore=gameVarScore+(int) ((percent-0.80f)*1000.0f*100.0f);
					if (percent>0.90f)
					  gameVarScore=gameVarScore+(int) ((percent-0.90f)*3000.0f*100.0f);
					if (percent>0.95f)
					  gameVarScore=gameVarScore+(int) ((percent-0.95f)*7000.0f*100.0f);
					if (percent>0.98f)
					  gameVarScore=gameVarScore+(int) ((percent-0.95f)*10000.0f*100.0f);
					
					
					// endLevel
					[self endLevel];
				}
				
			
			
			}
			

		}
		
		
		

	}

					// ------------------------------------------
					// project bonusObjects to PlayField
					// ------------------------------------------
					//
					// projectBonusObjectsToPlayField
					- (void)  projectBonusObjectsToPlayField
					{
						// NSLog(@"l1neumView.projectBonusObjectsToPlayField");
						
						int z=0;
						for (z=0;z<[objects count];++z)
						{

							tpObject * to=[objects objectAtIndex:z];

							// 	NSLog(@"l1neumView.projectBonusObjectsToPlayField.list(%d / %d)",[to status],[to typeId]);

							// ready ..
							if ([to status]==3)
							if ([to typeId]==3)
							{
								// NSLog(@"l1neumView.projectBonusObjectsToPlayField.found(%d)",z);
								
								// get it ...
								int wx=(int) ([to getPosition]).x;
								int wy=(int) ([to getPosition]).y;
								int wxstop=wx+(int) ([to size]).x;
								int wystop=wy+(int) ([to size]).y;
							
								// version 1.0b
								/*
								int dz=0;
								int dzz=0;
								for (dz=wx;dz<wxstop;++dz)
								 for (dzz=wy;dzz<wystop;++dzz)
								 if ((dz==wx) || (dzz==wy) || (dz==wxstop-1) || (dzz==wystop-1)) 
								 if (playField[dz][dzz]==0)
								 {
									playField[dz][dzz]=9;
								 }
								 */
								 int dz=0;
								 int dzz=0;
								 // *****
								 // |   |
								 // -----
								 dz=0;
								 dzz=wy;
								 for (dz=wx;dz<wxstop;++dz)
								 if (playField[dz][dzz]==0)
								 {
									playField[dz][dzz]=9;
								 }
								 // -----
								 // |   |
								 // *****
								 dz=0;
								 dzz=wystop;
								 for (dz=wx;dz<wxstop;++dz)
								 if (playField[dz][dzz]==0)
								 {
									playField[dz][dzz]=9;
								 }
								 
								 // -----
								 // *   |
								 // -----
								 dz=wx;
								 dzz=0;
								 for (dzz=wy;dzz<wystop;++dzz)
								 if (playField[dz][dzz]==0)
								 {
									playField[dz][dzz]=9;
								 }
								 // -----
								 // |   *
								 // -----
								 dz=wxstop;
								 dzz=0;
								 for (dzz=wy;dzz<wystop;++dzz)
								 if (playField[dz][dzz]==0)
								 {
									playField[dz][dzz]=9;
								 }
								 
								 
							}
						}					
					
					}
					// removeBonusObjectsToPlayField
					- (void)  removeBonusObjectsToPlayField
					{
						int z=0;
						for (z=0;z<[objects count];++z)
						{

							tpObject * to=[objects objectAtIndex:z];

							// 	NSLog(@"l1neumView.projectBonusObjectsToPlayField.list(%d / %d)",[to status],[to typeId]);

							// ready ..
							if ([to status]==3)
							if ([to typeId]==3)
							{
								// NSLog(@"l1neumView.projectBonusObjectsToPlayField.found(%d)",z);
								
								// get it ...
								int wx=(int) ([to getPosition]).x;
								int wy=(int) ([to getPosition]).y;
								int wxstop=wx+(int) ([to size]).x;
								int wystop=wy+(int) ([to size]).y;
							
								// version 2.0f
								/*
								int dz=0;
								int dzz=0;
								for (dz=wx;dz<wxstop;++dz)
								 for (dzz=wy;dzz<wystop;++dzz)
								 if ((dz==wx) || (dzz==wy) || (dz==wxstop-1) || (dzz==wystop-1)) 
								 if (playField[dz][dzz]==9)
								 {
									playField[dz][dzz]=0;
								 }
								 */
								 int dz=0;
								 int dzz=0;
								 // *****
								 // |   |
								 // -----
								 dz=0;
								 dzz=wy;
								 for (dz=wx;dz<wxstop;++dz)
								 if (playField[dz][dzz]==9)
								 {
									playField[dz][dzz]=0;
								 }
								 // -----
								 // |   |
								 // *****
								 dz=0;
								 dzz=wystop;
								 for (dz=wx;dz<wxstop;++dz)
								 if (playField[dz][dzz]==9)
								 {
									playField[dz][dzz]=0;
								 }
								 
								 // -----
								 // *   |
								 // -----
								 dz=wx;
								 dzz=0;
								 for (dzz=wy;dzz<wystop;++dzz)
								 if (playField[dz][dzz]==9)
								 {
									playField[dz][dzz]=0;
								 }
								 // -----
								 // |   *
								 // -----
								 dz=wxstop;
								 dzz=0;
								 for (dzz=wy;dzz<wystop;++dzz)
								 if (playField[dz][dzz]==9)
								 {
									playField[dz][dzz]=0;
								 }
							}
						}		
					}

	
	
		// endLevel
		-(void) endLevel
		{
			// play sound
			[self playSoundEffect:@"nextLevel"];
						
			// doThreadObjects
			[self doThreadObjects];
			
			systemModeSub=4;
			debugRotateF=true;
		
			// nextLevel
			// set Timeout
			menuTimer=30.0f;
		}
	
			// resetRunner
			- (void) resetRunners
			{
				[enemyRunner1 setStatus:0];
				[enemyRunner1 resetRunner];
				[enemyRunner2 setStatus:0];
				[enemyRunner2 resetRunner];
			}
			
		// fillPlaygroundExtended
		// recursive
		- (void) fillPlaygroundExtended
		{
			BOOL breakF=true;
			
			BOOL debugthis=true;	
		
			// for
			BOOL breakFor=false;
			int z=0;
			int zz=0;
			for (z=0;z<playFieldCountX;++z)
			{
				 for (zz=0;zz<playFieldCountY;++zz)
				 {
					if ((playField[z][zz]==5) || (playField[z][zz]==4))
					if (
					        (playField[z-1][zz]==0)
					     || (playField[z+1][zz]==0)
					     || (playField[z][zz-1]==0)
					     || (playField[z][zz+1]==0)
					   ) 
					{
						breakF=false;
						
						// NSLog(@"l1neumView.fillPlayground(%d,%d)",z,zz);
						
						// set to done
						playField[z][zz]=4;
						
						int i=0;
						for (i=z-1;i>=1;--i)
						{ if (playField[i][zz]==0) playField[i][zz]=4; else break; }
						for (i=z+1;i<playFieldCountX;++i)
						{ if (playField[i][zz]==0) playField[i][zz]=4; else break; }
						
						
						for (i=zz-1;i>=1;--i)
						{ if (playField[z][i]==0) playField[z][i]=4; else break; }
						for (i=zz+1;i<playFieldCountY;++i)
						{ if (playField[z][i]==0) playField[z][i]=4; else break; }
						
						
						breakFor=true;
						
						// break;
					}
				  }
			  
			  if (breakFor)
			   break;
			 }
			 
			 
			 // breakF
			 if (!breakF)
			   [self fillPlaygroundExtended];
		}
		/*
		- (void) fillPlaygroundExtended
		{   
			BOOL breakF=true;
			
			BOOL debugthis=true;
			 
		
			// NSLog(@"l1neumView.fillPlayground");
		
			int z=0;
			int zz=0;
			int posx=-1;
			int posy=-1;
			
			long counter=0;
				
		    BOOL find=true;
			do
			{
				
				posx=-1;
				posy=-1;
				
				for (z=0;z<playFieldCountX;++z)
				{
					 for (zz=0;zz<playFieldCountY;++zz)
					 {
						if (
						    ((playField[z][zz]==4) || (playField[z][zz]==5))
						    &&
						    (
								  (playField[z+1][zz]==0)	
							   || (playField[z-1][zz]==0)	 
							   || (playField[z][zz-1]==0)	 
							   || (playField[z][zz+1]==0)	 
							)
						   )
						{
							posx=z;
							posy=zz;
							break;
						}
					}
					
					// break it ..
					if (posx!=-1) 
					 if (posy!=-1)
					  break;
				}
				
				++counter;
				if (debugthis)   
				  NSLog(@"l1neumView.fillPlaygroundExtended:count=%d - position [%d,%d]",counter,posx,posy);
				
				
				
				// found posx+posy
				if ((posx!=-1) && (posy!=-1))
				{
					// back to 0
					playField[posx][posy]=0;
					
					// -->
					int p=0;
					for (p=posx;p<playFieldCountX;++p)
					{
					  if (playField[p][posy]==0)
					  {
						playField[p][posy]=4;
					  }
					  else
					  {
						   if (debugthis)  NSLog(@"l1neumView.fillPlaygroundExtended:found-right(%d)",p-posx);
						  break;
					  }
					}
					
					// <--
					for (p=posx-1;p>=0;--p)
					{
					  if (playField[p][posy]==0)
					  {
							playField[p][posy]=4;
					   }
					   else
					  {
						  if (debugthis) NSLog(@"l1neumView.fillPlaygroundExtended:found-left(%d)",p-posx);
						  break;
					  }
					}
					
					
					
					// ^
					// |
					for (p=posy-1;p>=0;--p)
					{
					  if (playField[posx][p]==0)
					  {
					  	playField[posx][p]=4;
					  }
					  else
					  {
						  if (debugthis) NSLog(@"l1neumView.fillPlaygroundExtended:found-up(%d)",p-posx);
						  break;
					  }
					}
					
					//  |
					// \/
					for (p=posy+1;p<playFieldCountY;++p)
					{
					  if (playField[posx][p]==0)
					  {
					    playField[posx][p]=4;
					  }
					  else
					  {
						  if (debugthis) NSLog(@"l1neumView.fillPlaygroundExtended:found-down(%d)",p-posx);
						  break;
					  }
					}
					
					
				}
				else
				// break
				{
					find=false;
				}
				
				
			}
			while (find);
			
			
						 
									 			 
		}
		*/
		
		// fillPlayground
		// recursive
		- (void) fillPlayground
		{   BOOL breakF=true;
		
			// NSLog(@"l1neumView.fillPlayground");
		
			// for
			BOOL breakFor=false;
			int z=0;
			int zz=0;
			for (z=0;z<playFieldCountX;++z)
			{
				 for (zz=0;zz<playFieldCountY;++zz)
				 {
					if (playField[z][zz]==5)
					{
						breakF=false;
						
						// NSLog(@"l1neumView.fillPlayground(%d,%d)",z,zz);
						
						// set to done
						playField[z][zz]=4;
						
						// 9 fields
						int p=0;
						int pp=0;
						
						for (p=-1;p<=1;++p)
						{
							 for (pp=-1;pp<=1;++pp)
							 if (playField[z+p][zz+pp]==0)
							 {
								playField[z+p][zz+pp]=5;
							 }
						}
						
						breakFor=true;
						
						// break;
					}
				  }
			  
			  if (breakFor)
			   break;
			 }
			 
			 
			 // breakF
			 if (!breakF)
			   [self fillPlayground];
		}

		
		// invertPlayground
		- (void) invertPlayground
		{   
			dotesCount=0;
			
		    int z=0;
			int zz=0;
			for (z=0;z<playFieldCountX;++z)
			{
				 for (zz=0;zz<playFieldCountY;++zz)
				 {
					// 0 -> 1
					if (playField[z][zz]==0)
					{
						playField[z][zz]=1;
					}
					
					// 4 -> 0
					if (playField[z][zz]==4)
					{
						playField[z][zz]=0;
					}
					
					// 3 -> 2
					if (playField[z][zz]==3)
					{
						playField[z][zz]=2;
					}
					
					// count
					if (playField[z][zz]!=0)
					  ++dotesCount;
				}
			}
		}
		
		// generateNewSecureLine
		- (void) generateNewSecureLine
		{   
		    int z=0;
			int zz=0;
			for (z=0;z<playFieldCountX;++z)
			{
				 for (zz=0;zz<playFieldCountY;++zz)
				 {
					// 2 - ? (other ++)
					if (playField[z][zz]==2)
					{
						if (
								(playField[z-1][zz-1]==0)
								||
								(playField[z][zz-1]==0)
								||
								(playField[z+1][zz-1]==0)
								||
								(playField[z-1][zz]==0)
								||
								(playField[z+1][zz]==0)
								||
								(playField[z-1][zz+1]==0)
								||
								(playField[z][zz+1]==0)
								||
								(playField[z+1][zz+1]==0)
						   )
						{
							
						}
						else
						{
						    // NSLog(@"l1neumView.generateNewSecureLine:not used anymore (%d,%d) ",z,zz);
							
							// 20 + flat add
							playField[z][zz]=20+flat;
						}
					}
					
				}
			}
			
		
		}
		
		// --------------------------------
		// generateWallsForDisplay
		// --------------------------------
		- (void) generateWallsForDisplay
		{
			// NSLog(@"l1neumView.generateWallsForDisplay");
			
			// clear all wall objects
			int q=0;
			for (q=0;q<[walls count];++q)
			{
				objectWall * to=[walls objectAtIndex:q];
				
				// redu
				if (false)
				{
					// let the use in it
					if ([to wallTypeId]==1)
					{
						[to setInUse:false];
					}
				}
				else
				{
					// normal walls
					// first time back
					if ([to wallTypeId]==1)
					{
						// dowgrad it
						[to setZ:[to z]+heightFloor];	
						[to setZZ:[to z]+heightFloor];				
					    [to setWallTypeId:3];
					}
					
					// down
					if ([to wallTypeId]==3)
					{
						// dowgrad it
						[to setZ:[to z]+heightFloor];
						[to setZZ:[to z]+heightFloor];

					}
				}	 
				// smaller walls there
				 
   			}
		
			// objectWall * 
			// get first object
			int startx=1;
			int starty=1;
			
			// z/zz
			int qz=0;
			int qzz=0;
			for (qz=0;qz<playFieldCountX;++qz)
			{
				 for (qzz=0;qzz<playFieldCountY;++qzz)
				 {
					// 2 - ? (other ++)
					if (playField[qz][qzz]==2)
					{
						startx=qz;
						starty=qzz;
						
						// tmp to 3
						playField[qz][qzz]=6;
					}
				}
			}
			
			// ...
			BOOL goOn=true;
			int tmpX=startx;
			int tmpY=starty;
			
			int tmpStartX=tmpX;
			int tmpStartY=tmpY;
			
			int directionX=0;
			int directionY=0;

			// 0 - no direction = to define 
			// directionX -1 +1
			// directionY -1 +1
			
			BOOL startStatus=true;
			
			int breakZ=0;
			do
			{
				++breakZ;
				if (breakZ>playFieldCountX*playFieldCountY) break;
				
				// goOn
				tmpX=tmpX+directionX;
				tmpY=tmpY+directionY;
				
				// convert
				if (playField[tmpX][tmpY]==6) 
				{
					if (!startStatus)
					  playField[tmpX][tmpY]=2;
				}
				else
				{
					// go back to the old position
					tmpX=tmpX-directionX;
					tmpY=tmpY-directionY;
					
					directionX= 0; 
					directionY= 0; 
				}
				
				// NSLog(@"l1neumView.1.generateWallsForDisplay(tmpX=%d/tmpY=%d/directionX=%d/directionY=%d)",tmpX,tmpY,directionX,directionY);
				
				// define it
				if ((directionX==0) && (directionY==0))
				{  
					if (playField[tmpX-1][tmpY]==6) { directionX=-1; directionY= 0; }
					if (playField[tmpX+1][tmpY]==6) { directionX= 1; directionY= 0; }
					if (playField[tmpX][tmpY-1]==6) { directionX= 0; directionY=-1; }
					if (playField[tmpX][tmpY+1]==6) { directionX= 0; directionY= 1; }
					
					// generate ...
					// walls 
					// NSLog(@"l1neumView.wall(%d-%d|%d-%d)",tmpStartX,tmpStartY,tmpX,tmpY);
					
					// add a wall
					[self addObjectWall:tmpStartX y:tmpStartY xx:tmpX yy:tmpY type:1 flat:flat];
					
					tmpStartX=tmpX;
					tmpStartY=tmpY;
					
				}
				
				// NSLog(@"l1neumView.2.generateWallsForDisplay(tmpX=%d/tmpY=%d/directionX=%d/directionY=%d)",tmpX,tmpY,directionX,directionY);
				
				
				// no direction
				if ((directionX==0) && (directionY==0))
				{
					break;
				}
				
				// stop it
				if (!startStatus)
				if (tmpX==startx)
				 if (tmpY==starty)
				 {
					// add last
				    // NSLog(@"l1neumView.wall(%d-%d|%d-%d)",tmpStartX,tmpStartY,tmpX,tmpY);
					
					// add a wall
					[self addObjectWall:tmpStartX y:tmpStartY xx:tmpX yy:tmpY type:1 flat:flat];
					
				    break;
				 } 
				
				// status
				startStatus=false;
			}
			while (goOn);
			
							
			// remove the fire line
			q=0;
			for (q=0;q<[walls count];++q)
			{
				objectWall * to=[walls objectAtIndex:q];
				
				if ([to wallTypeId]==2)
				// let the use in it
				   [to setInUse:false];
   			}
			
			
			// ------------------
			// generate floor
			// ------------------
			// 
			[self generateBoxFloor];
			
		}
		
		// --------------------------------
		// generateWallsFireLineForDisplay
		// --------------------------------
		- (void) generateWallsFireLineForDisplay
		{
			// NSLog(@"l1neumView.generateWallsForDisplay");
			
			// clear all wall objects
			int q=0;
			for (q=0;q<[walls count];++q)
			{
				objectWall * to=[walls objectAtIndex:q];
				
				if ([to wallTypeId]==2)
				// let the use in it
				   [to setInUse:false];
   			}
		
			// objectWall * 
			// get first object
			int startx=1;
			int starty=1;
			
			// z/zz
			int qz=0;
			int qzz=0;
			for (qz=0;qz<playFieldCountX;++qz)
			{
				 for (qzz=0;qzz<playFieldCountY;++qzz)
				 {
					// 2 - ? (other ++)
					if (playField[qz][qzz]==3)
					{
						// tmp to 6
						playField[qz][qzz]=6;
					}
				}
			}
			
			
			// startpoint 
			startx=([representation getPosition]).x;
			starty=([representation getPosition]).y;
			
			
			// ...
			BOOL goOn=true;
			int tmpX=startx;
			int tmpY=starty;
			
			int tmpStartX=tmpX;
			int tmpStartY=tmpY;
			
			int directionX=0;
			int directionY=0;

			// 0 - no direction = to define 
			// directionX -1 +1
			// directionY -1 +1
			
			// BOOL startStatus=true;
			
			
			// ...
			int breakZ=0;
			do
			{
				++breakZ;
				if (breakZ>900) break;
				
				// goOn
				tmpX=tmpX+directionX;
				tmpY=tmpY+directionY;
				
				// convert
				if (playField[tmpX][tmpY]==6) 
				{
					// if (!startStatus)
					  playField[tmpX][tmpY]=3;
				}
				else
				{
					// go back to the old position
					tmpX=tmpX-directionX;
					tmpY=tmpY-directionY;
					
					directionX= 0; 
					directionY= 0; 
				}
				
				// NSLog(@"l1neumView.1.generateWallsForDisplay(tmpX=%d/tmpY=%d/directionX=%d/directionY=%d)",tmpX,tmpY,directionX,directionY);
				
				// define it
				if ((directionX==0) && (directionY==0))
				{  
					if (playField[tmpX-1][tmpY]==6) { directionX=-1; directionY= 0; }
					if (playField[tmpX+1][tmpY]==6) { directionX= 1; directionY= 0; }
					if (playField[tmpX][tmpY-1]==6) { directionX= 0; directionY=-1; }
					if (playField[tmpX][tmpY+1]==6) { directionX= 0; directionY= 1; }
					
					// generate ...
					// walls 
					// NSLog(@"l1neumView.wall(%d-%d|%d-%d)",tmpStartX,tmpStartY,tmpX,tmpY);
					
					
					
					// add a wall
					[self addObjectWall:tmpStartX y:tmpStartY xx:tmpX yy:tmpY type:2];
					
					tmpStartX=tmpX;
					tmpStartY=tmpY;
					
				}
				
				// NSLog(@"l1neumView.2.generateWallsForDisplay(tmpX=%d/tmpY=%d/directionX=%d/directionY=%d)",tmpX,tmpY,directionX,directionY);
				
				
				// no direction
				if ((directionX==0) && (directionY==0))
				{
					// add a wall
					[self addObjectWall:tmpStartX y:tmpStartY xx:tmpX yy:tmpY type:2];
					
					break;
				}
				
				 
				
				// status
				// startStatus=false;
			}
			while (goOn);
			
			// display first
			// first wall
			[self addObjectWall:oldPositionX y:oldPositionY xx:tmpStartX yy:tmpStartY type:2];
	
			
			// revert
			for (qz=0;qz<playFieldCountX;++qz)
			{
				 for (qzz=0;qzz<playFieldCountY;++qzz)
				 {
					// 2 - ? (other ++)
					if (playField[qz][qzz]==6)
					{
						playField[qz][qzz]=3;
					}
				}
			}
							
		}		
		
			// --------------------
			// walls 
			// --------------------
			// addWall + flat
			- (void) addObjectWall:(int)x y:(int)y xx:(int)xx yy:(int)yy type:(int)type flat:(int)flat
			{
					// NSLog(@"l1neumView.addObjectWall(%d-%d/%d-%d) type=%d",x,y,xx,yy,type);
					objectWall * wo=[self getObjectWall];
					[wo setWallTypeId: type];
					[wo setLeftCorner:NSMakePoint(x,y)];
					[wo setZ:0];
					[wo setRightCorner:NSMakePoint(xx,yy)];
					[wo setZZ:4];
					[wo setFlatNumber:flat];
					[wo setVertical:true];
					// fireline
					if (type==2)
					{
					 [wo setZZ:-1];
					 [wo setZZ:1];
					}
			}
		
			// addWall
			- (void) addObjectWall:(int)x y:(int)y xx:(int)xx yy:(int)yy type:(int)type
			{
					[self addObjectWall: x y:y xx:xx yy:yy type:type flat:0 ];
			}
			
			// getObjectWall
			- (objectWall *) getObjectWall
			{
				BOOL foundInArray=false;
				
				int z=0;
				for (z=0;z<[walls count];++z)
				{
					objectWall * to=[walls objectAtIndex:z];
				
					if (![to inUse])
					if (![to vertical])
					{
						foundInArray=true;
						[to initObject];
						return to;
						break;
					}
				}
				
				// not found - generate new one
				if (!foundInArray)
				{
				  objectWall * ow=[[objectWall alloc] init];
							   [ow initObject]; 
				  [walls addObject: ow];			     
				  return ow;
				}
			
			}
		
		

			// --------------------
			// floor 
			// --------------------
			// addObjectFloor
			- (void) addObjectFloor:(int)x y:(int)y xx:(int)xx yy:(int)yy type:(int)type flat:(int)flat
			{
					// NSLog(@"l1neumView.addObjectWall(%d-%d/%d-%d) type=%d",x,y,xx,yy,type);
					objectWall * wo=[self getObjectFloor];
					[wo setWallTypeId: type];
					[wo setLeftCorner:NSMakePoint(x,y)];
					[wo setZ:0];
					[wo setRightCorner:NSMakePoint(xx,yy)];
					[wo setZZ:3];
					[wo setFlatNumber:flat];
					[wo setVertical:false];
			}
		
			// addObjectFloor
			- (void) addObjectFloor:(int)x y:(int)y xx:(int)xx yy:(int)yy type:(int)type
			{
					[self addObjectFloor: x y:y xx:xx yy:yy type:type flat:0 ];
			}
			
			// getObjectFloor
			- (objectWall *) getObjectFloor
			{
				BOOL foundInArray=false;
				
				int z=0;
				for (z=0;z<[walls count];++z)
				{
					objectWall * to=[walls objectAtIndex:z];
				
					if (![to inUse])
					if (![to vertical])
					{
						foundInArray=true;
						[to initObject];
						return to;
						break;
					}
				}
				
				// not found - generate new one
				if (!foundInArray)
				{
				  objectWall * ow=[[objectWall alloc] init];
							   [ow initObject]; 
				  [walls addObject: ow];			     
				  return ow;
				}
			
			}
		

		
		
		
	// do action - 
	- (void) doAction: (BOOL) stat 
	{
		// set representation
		[representation setAvaibleOffLine:true];
	}
		
			


	// ----------------------
	// soundeffect center
	// ----------------------
	// problem: NSSound release seams not to work
	//          the dealloc doesn't work ?
	// -> temp. solution > pooling 
	// better: low memory usage
	- (void) playSoundEffect:(NSString *)nsstringSoundx
	{
		BOOL parsed=false;
	
		// NSLog(@"l1neumView.play: count pooled soundeffects: %d - searchfor %@",[soundEffectsArray count],nsstringSoundx);
	
			// check if a non-playing is available ?
			BOOL found=false;
			int u=0;
			for (u=0;u<[soundEffectsArray count];++u)
			{
				NSSound * tmpsound=[soundEffectsArray objectAtIndex:u];
				if ([[soundEffectsName objectAtIndex:u] isEqualToString:nsstringSoundx])
				 if (![tmpsound  isPlaying])
				 {
					// NSLog(@"l1neumView.play %d",u);
					[tmpsound play];
					found=true;
					parsed=true;
					break;
				 }
			} 
			
			// add new ?
			if (!found)
			{
				// avalaible soundss

				// ------------------
				// menusounds
				// ------------------
				
				// menuNextPoint
				if ([nsstringSoundx isEqualToString:@"menuNextPoint"])
				{	parsed=true;
					// new sound + add it
					NSSound * xsound=[soundMenuNextPoint copy];
					[[xsound autorelease] play];
					// add to the center
					[soundEffectsArray addObject:xsound];
					[soundEffectsName addObject:nsstringSoundx];
				}
				
				// menuClicked
				if ([nsstringSoundx isEqualToString:@"menuClicked"])
				{	parsed=true;
					// new sound + add it
					NSSound * xsound=[soundMenuPointDone copy];
					[[xsound autorelease] play];
					// add to the center
					[soundEffectsArray addObject:xsound];
					[soundEffectsName addObject:nsstringSoundx];
				}
				
				
				// ------------------
				// game in sound
				// ------------------
				// soundEnemyDie
				if ([nsstringSoundx isEqualToString:@"enemyDie"])
				{	parsed=true;
					// new sound + add it
					NSSound * xsound=[soundEnemyDie copy];
					[[xsound autorelease] play];
					// add to the center
					[soundEffectsArray addObject:xsound];
					[soundEffectsName addObject:nsstringSoundx];
				}
				// soundEnemyDieHard
				if ([nsstringSoundx isEqualToString:@"enemyDieHard"])
				{	parsed=true;
					// new sound + add it
					NSSound * xsound=[soundEnemyDieHard copy];
					[[xsound autorelease] play];
					// add to the center
					[soundEffectsArray addObject:xsound];
					[soundEffectsName addObject:nsstringSoundx];
				}
				
				// big boss
				// soundEnemyDieHard
				if ([nsstringSoundx isEqualToString:@"bigBossShoot"])
				{	parsed=true;
					// new sound + add it
					NSSound * xsound=[soundBigBossShoot copy];
					[[xsound autorelease] play];
					// add to the center
					[soundEffectsArray addObject:xsound];
					[soundEffectsName addObject:nsstringSoundx];
				}
				// enemyBoing
				if ([nsstringSoundx isEqualToString:@"enemyBoing"])
				{	parsed=true;
					// new sound + add it
					NSSound * xsound=[soundEnemyBoing copy];
					[[xsound autorelease] play];
					// add to the center
					[soundEffectsArray addObject:xsound];
					[soundEffectsName addObject:nsstringSoundx];
				}
				
				
				// ----------------
				// bonus
				// ----------------
				// soundBonusFree
				if ([nsstringSoundx isEqualToString:@"bonusFree"])
				{	parsed=true;
					// new sound + add it
					NSSound * xsound=[soundBonusFree copy];
					[[xsound autorelease] play];
					// add to the center
					[soundEffectsArray addObject:xsound];
					[soundEffectsName addObject:nsstringSoundx];
				}
				
				// ----------------
				// representation
				// ----------------
				// representationDie
				if ([nsstringSoundx isEqualToString:@"representationDie"])
				{	parsed=true;
					// new sound + add it
					NSSound * xsound=[soundVesselDie copy];
					[[xsound autorelease] play];
					// add to the center
					[soundEffectsArray addObject:xsound];
					[soundEffectsName addObject:nsstringSoundx];
				}
				
				// soundFireLineEnd
				if ([nsstringSoundx isEqualToString:@"fireLineEnd"])
				{	parsed=true;
					// new sound + add it
					NSSound * xsound=[soundFireLineEnd copy];
					[[xsound autorelease] play];
					// add to the center
					[soundEffectsArray addObject:xsound];
					[soundEffectsName addObject:nsstringSoundx];
				}
				
				// no way
				if ([nsstringSoundx isEqualToString:@"noWay"])
				{	parsed=true;
					// new sound + add it
					NSSound * xsound=[soundNextLevel copy];
					[[xsound autorelease] play];
					// add to the center
					[soundEffectsArray addObject:xsound];
					[soundEffectsName addObject:nsstringSoundx];
				}
				
				// ----------------
				// gameOver
				// ----------------
				if ([nsstringSoundx isEqualToString:@"gameOver"])
				{	parsed=true;
					// new sound + add it
					NSSound * xsound=[soundGameOver copy];
					[[xsound autorelease] play];
					// add to the center
					[soundEffectsArray addObject:xsound];
					[soundEffectsName addObject:nsstringSoundx];
				}
				
				// ----------------
				// nextLevel
				// ----------------
				if ([nsstringSoundx isEqualToString:@"nextLevel"])
				{	parsed=true;
					// new sound + add it
					NSSound * xsound=[soundNextLevel copy];
					[[xsound autorelease] play];
					// add to the center
					[soundEffectsArray addObject:xsound];
					[soundEffectsName addObject:nsstringSoundx];
				}
				
				
				
			}	
		
		// parsed
		if (!parsed)
		  NSLog(@"l1neumView.playSoundEffect: Could not find:%@",nsstringSoundx);
	}


	// ---------------------
	// draw3DString
	// ---------------------
	- (void) draw3DString: (NSString *) str x: (float) x y: (float) y z:(float) z fontsize:(float)fontsize
	{
		// no kerning at the moment :-(
		// will be in further version ..
	
		BOOL debugThis=false;
	
		// vector 
		// float fontsize=0.25f;
		
		// temp x
		float xt=x;
		float yt=y;
		float zt=z;
		float zzt=z;
		
		
		if (debugThis) NSLog(@"draw3DString");
		
		// if (false)
		
		int len=[str length];
		if (debugThis) NSLog(@"draw3DString.length=%d",len);
		int localcounter=0;
		for (localcounter=0;localcounter<len;++localcounter)
		{
		    //  NSLog(@"----%d",localcounter);
			char t=[str characterAtIndex:localcounter];
			int d=(int) t; // [t intValue];
			if (debugThis) NSLog(@"%c=%d",t,d);
			
			
			// font ... 
			int fontTexture=textureNumber;
			
			// ascii
			int ascii=-1;
			
			// numberint
			int numberint=-1;
			
			// scale
			float scale=1.0f;
			
			BOOL doThisChar=false;
			
			// normal
			float normalRange=45.0f;
			
			// 0-9
			if (d>47)
			 if (d<58)
			 {
				
				fontTexture=textureNumber+(d-48);
				numberint=d-48;
				
				scale=normalRange/64.0f;
				doThisChar=true;
			}
			
			// a-z
			// 97-122
			if (d>96)
			 if (d<123)
			 {
			    fontTexture=textureChars+(d-97);
				scale=normalRange/64.0f;
				ascii=d-97;
				doThisChar=true;
			 }
			
			// A-Z
			// 65-90
			if (d>64)
			 if (d<91)
			 {
			    fontTexture=textureChars+(d-64);
				scale=normalRange/64.0f;
				ascii=d-64;
				doThisChar=true;
			 }
			
			// ok display it and take next one
			// if (true)
			if (d!=32) // no space
			if (doThisChar)
			{
				// fontTexture 
				glBindTexture( GL_TEXTURE_2D, textureArray[ fontTexture ] );
				
								
				[self displayFlatDirectNormal:xt y:yt z:zt xx:xt+fontsize yy:yt+fontsize ]; 
											
				
			}
			
			// fontsize
			
			// numberint
			if (numberint==1)  scale=40.0f/64.0f;
			if (numberint==9)  scale=45.0f/64.0f;
			 
			
			// bigger ? m / w ...
			if (
				(ascii==12)
				||
				(ascii==22)
				)
			{
			  scale=64.0f/64.0f;
			}
			// smaller ? i j l 
			if 
				(
				 (ascii==8)
				 || 
				 (ascii==9)
				 || 
				 (ascii==11)
				 || 
				 (ascii==19)
				)
			{
				scale=30.0f/64.0f;
			}
			
			// NSLog(@"l1neumView.draw3DString %d   scale:%f",ascii,scale);
			
			xt=xt+fontsize*scale;
			
			  // NSLog(@"%f %f",xt,zt);		
				// zt=zt-0.01f;
			
		}
		
		
	}



@end
