/* 
   code by la1n.ch
   more details:  "about the source ... " 
*/



//  tboEnemy.m

#import "tboEnemy.h"
#import "tpObject.h"

@implementation tboEnemy : tpObject

// initObject
	- (void) initObject
	{
		[super initObject];
		
		// enemy
		typeId=4;
		
		// touch
		touchFireLineF=false;
		touchX=-1;
		touchY=-1;
		
		// size
		[self setSize:NSMakePoint(30,30)];
		
		// random direction
		direction.x=(float) (SSRandomIntBetween(-1,1));
		direction.y=(float) (SSRandomIntBetween(-1,1));
		
		if ((direction.y==0) && (direction.y==0))
		{
			direction.x=-1;
			direction.y=-1;
		 }
		 
		 // generate direction
		 direction.x=direction.x/3.0f;
		 direction.y=direction.y/3.0f;
		 
		 // killed ?
		 killedFlag=false;
		 
		 // bounce flag
		 bounceFlag=false;
		
	}

// -------------------------
// doThread
// -------------------------
// 
- (void) doThread: (int[420][420]) tf
{
	// NSLog(@"tpObject.doThread");
	// go on ...
	
	// enemy
	// if (false)
	
	
	// move here
	[self move:tf];
	
	// touch fireline
	[self touchFireLine:tf];
	
	// enemy in enemy's land ?
	BOOL inland=[self inLiberatedLand:tf];
	
	// time to die
	// start
	
	if (inland)
	{
		// go home to vectore
		if (status==3)
		{
			status=2;
			
			[self setTimer:10.0f];
		}
		
		// go down
		if (status==2)
		{
		   [self setTimer:[self timer]-0.3f];
		   
		   // time to die
			if ([self timer]<0.5f)
			{
				status=0;
				killedFlag=true;
			}
		}
						
	
		// NSLog(@"tboEnemy.doThread. timer=%f",[self timer]);
	}
}

// --------------
// touchFireLine ?
// --------------
-(BOOL) touchFireLine: (int[420][420]) tf
{
  // NSLog(@"tboEnemy.touchFireLine");
  
  // ok check here
  BOOL iTouchFireLineF=false;
  
  // check it now
  // go on check
  int posx=(int) location.x;
  int posy=(int) location.y;
  
  int u=0;
  // -----
  for (u=0;u<(int) size.x;++u)
  {
     if (tf[posx+u][posy]==3)
	 {
		touchX=posx+u;
		touchY=posy;
	    iTouchFireLineF=true;
		break;
	 }
  }
  
  // -----
  //  
  // *****
  for (u=0;u<(int) size.x;++u)
  {
     if (tf[posx+u][posy+(int) (size.y)]==3)
	 {
		touchX=posx+u;
		touchY=posy+(int) (size.y);

	    iTouchFireLineF=true;
		break;
	 }
  }

 
  // -----
  // *
  // -----
  for (u=0;u<(int) size.y;++u)
  {
     if (tf[posx][posy+u]==3)
	 {
		touchX=posx;
		touchY=posy+u;

	    iTouchFireLineF=true;
		break;
	 }
  }

  // -----
  // |	 *
  // -----
  for (u=0;u<(int) size.y;++u)
  {
     if (tf[posx+(int) (size.x)][posy+u]==3)
	 {
		touchX=posx+(int) (size.x);
		touchY=posy+u;


	    iTouchFireLineF=true;
		break;
	 }
  }

 if (iTouchFireLineF)
 {
	// NSLog(@"tboEnemy.touchFireLine");
 }

   touchFireLineF=iTouchFireLineF;
}

// touchFire
- (BOOL) touchFire
{
	return touchFireLineF;
}

// getFireX
- (int) getFireX
{
	return touchX;
}

// getFireY
- (int) getFireY
{
	return touchY;
}


	
	// --------------
	// move
	// --------------
	- (void) move:(int[420][420]) tf
	{
	
		// don't fly
		if (!flyingFlag)
		{
			[self doMove:tf];
		}
			
		// fly
		if (flyingFlag)
		{
			[self doMoveFly:tf];
		}

	}
	
		// fly
		// doMoveFly
		- (void) doMoveFly:(int[420][420]) tf
		{
		
		  if (status==3)
		  {
			location.x=location.x+direction.x;
			location.y=location.y+direction.y;
			
			// disable at the end of the flat
			if (location.x<5.0f)
				status=0;
			if (location.x>395.0f)
				status=0;
			if (location.y<5.0f)
				status=0;		
			if (location.y>395.0f)
				status=0;	
	 	
			 // store ... killed
			 killedFlag=true;
		   }
		}
				
				// killed and reset
				- (BOOL) checkKilled
				{
					if (killedFlag)
					{
						killedFlag=false;
						return true;
					}
					else
					return killedFlag;
				}
				
				// setKilledFlag
				- (BOOL) setKilledFlag: (BOOL) OO
				{
					killedFlag=OO;
				}
		
		// doMove
		- (void) doMove:(int[420][420]) tf
		{
			// doMoveBounce
			[self doMoveBounce:tf];
			
		}
		
	
			- (void) doMoveBounce:(int[420][420]) tf
			{
			
				BOOL fTouched=false;
				
				// x-direction
				// <--
				if (direction.x<0)
				{
					// 
					int yz=0;
					BOOL fTouch=false;
					for (yz=0;yz<(int) size.y;++yz)
					{
						if (
							(tf[(int)(location.x+direction.x)][(int)(location.y)+yz]==0)
							||
							(tf[(int)(location.x+direction.x)][(int)(location.y)+yz]==3)
							)
						{
							
						}
						else
						{
							fTouch=true;
							fTouched=true;
							break;
						}
					}
					
					// no touch ?
					if (!fTouch)
					{
					   location.x=location.x+direction.x;
					}
					
					// touch ?
					if (fTouch)
					{
					   direction.x=direction.x*(-1);
					}
				}
				else
				// -->
				{
					// NSLog(@"tboEnemy.doThread --> %d",(int) (location.x+direction.x+(int) (size.x)));
					
					
					// 
					int yz=0;
					BOOL fTouch=false;
					for (yz=0;yz<(int) size.y;++yz)
					{
						if (
							(tf[(int)(location.x+direction.x+(int) (size.x))][(int)(location.y)+yz]==0)
							||
							(tf[(int)(location.x+direction.x+(int) (size.x))][(int)(location.y)+yz]==3)
							)
						{
							
						}
						else
						{
							fTouch=true;
							fTouched=true;
							break;
						}
					}
					
					// no touch ?
					if (!fTouch)
					{
					   location.x=location.x+direction.x;
					}
					
					// touch ?
					if (fTouch)
					{
					   direction.x=direction.x*(-1);
					}
				}
				
				// size
				
				// y-direction
				// up
				if (direction.y<0)
				{
					
					// 
					int yz=0;
					BOOL fTouch=false;
					for (yz=0;yz<(int) size.y;++yz)
					{
						if (
							(tf[(int)(location.x)+yz][(int)(location.y+direction.y)]==0)
							||
							(tf[(int)(location.x)+yz][(int)(location.y+direction.y)]==3)
							)
						{
							
						}
						else
						{
							fTouch=true;
							fTouched=true;
							break;
						}
					}
					
					// no touch ?
					if (!fTouch)
					{
					   location.y=location.y+direction.y;
					}
					
					// touch ?
					if (fTouch)
					{
					   direction.y=direction.y*(-1);
					}
				}
				else
				// down
				{
					
					// 
					int yz=0;
					BOOL fTouch=false;
					for (yz=0;yz<(int) size.y;++yz)
					{
						if (
							(tf[(int)(location.x)+yz][(int)(location.y+direction.y+(int) size.y)]==0)
							||
							(tf[(int)(location.x)+yz][(int)(location.y+direction.y+(int) size.y)]==3)
							)
						{
							
						}
						else
						{
							fTouch=true;
							fTouched=true;
							break;
						}
					}
					
					// no touch ?
					if (!fTouch)
					{
					   location.y=location.y+direction.y;
					}
					
					// touch ?
					if (fTouch)
					{
					   direction.y=direction.y*(-1);
					}
				}
				
				// bounce ?
				if (fTouched)
				{
					bounceFlag=true;
				}

			}
			
			
			// checkBounceFlag
			- (BOOL) bounceFlag
			{
				if (bounceFlag)
				{
					bounceFlag=false;
					return true;
				}
				else
				return false;
			}
	
	
@end
